#include "cb.h"
#include "init.h"

static char it_config[] = prefix "/lib/cb/cb07.config";
static char it_help[]   = prefix "/lib/cb/cb07.help";
static char *it_fifo[] = {
  ".fifo.cb._???????????",
  "fifo.cb",
};
static char it_err[] = "cb0???.err"	;
static char it_version[] = "cb v0.??? < TOWNS-Linux version >";
static char it_note[] = "
 ե󥯥

         C_? : CTRL?  S_? : SHIFT?  M_? : ESC θ ? 
";
static struct {
  int font;
  int shmid;
  int cons;	/* ǽ tty8 ذܤü */
} init;
void exec_cb(char *pathname, int cons0)/*cb*/
{
  int i, s_pid, arg[6];
  struct stat st;
  static CB cb_a[1];

  check_dev("/dev/mouse", O_RDONLY);
  check_dev("/dev/fb", O_RDWR);
  check_dev("/dev/console", O_RDWR);
  check_dev("/dev/krom", O_RDONLY);
  if ((init.shmid = shmget(IPC_CB+gl.curr, SHMCB_SIZE, 0666)) < 0)
    if ((init.shmid = shmget(IPC_CB+gl.curr, SHMCB_SIZE, IPC_CREAT|0666)) < 0){
      /* IPC_CB ¾ΥץǻѤƤ */
      perror("IPC_CB");
      exit(1);
    }  
  cb = (CB*)shmat(init.shmid, 0, 0);
  if (pathname && !strcmp(pathname, "-")) {
    s_pid = cb->s_pid;
    pathname = NULL;
  } else s_pid = 0;
  memcpy(cb, cb_a, sizeof(CB)); /* ͭꥯꥢ */
  cb->rline = 16;
  cb->crt.ws = 1; /* (stdin) κݤ WS */
  cb->crt.wid = 18; /* Ʊ WID */
  init.cons = cons0;
  if (s_pid) {
    cb->s_pid = s_pid;
    set_magic(M_FORK|M_INIT);
  }
  init_chp(1, NULL, NULL); /* (cb07.config)EDITOR, LOOP  */
  if (!cb->loop) /* LOOP ̤ʤ¬ */
    calib_loop();
  else {
    gl.loop = -cb->loop;
    cb->loop = 0;
  }
  set_delay(gl.loop); /* ͤǽ */
  gl.tfd = open("/dev/console", O_RDWR);
  get_conspal();  /* 󥽡Υѥåȼ */
  gl.kfd = open("/dev/krom", O_RDONLY);
  do {
    if ((init.font = (int)valloc(ANK_SIZE)) != 0)
      if ((init.font = (int)mmap((caddr_t)init.font, ANK_SIZE,
				 PROT_READ, MAP_SHARED|MAP_FIXED, 
				 gl.kfd, ANK_ADDR)) >= 0) continue;
    fprintf(stderr, "cb: /dev/krom: %s\n", strerror(errno));
    shmdt((char*)cb);
    close(gl.kfd);
    exit(1);
  } while (0);
  gl.ffd = open("/dev/fb", O_RDWR);
  do {
    if (ioctl(gl.ffd, FBIOCGETINFO, arg) >= 0) 
      if ((gl.fb = (int)valloc(VRAM_SIZE)) != 0)
	if ((gl.fb = (int)mmap((caddr_t)gl.fb, VRAM_SIZE,
			    PROT_READ|PROT_WRITE, MAP_SHARED|MAP_FIXED,
			    gl.ffd, arg[4])) >= 0) continue;
    fprintf(stderr, "cb: /dev/fb: %s\n", strerror(errno));
    shmdt((char*)cb);
    close(gl.kfd);
    close(gl.ffd);
    exit(1);
  } while (0);
  cb->cons = init.cons;
  cb->y = MY+2;
  *cb->errormes = 0;
  cb->f.ff = 1; /* printtime  */
  vraminit(gl.fb, init.font);
  gl.end = vramgetaddr(NULL, &gl.bf);
  errno = 0;
  init_color(9, gl.convdata);
  gl.bp = gl.base;
  if (!gl.curr) {
    cb->k_pid = getpid();
    unlink(gl.fifo[1]);
    mknod(gl.fifo[1], 010777, 0);
    if (gl.err && stat(gl.err, &st) < 0) { /* LOG  */
      close(creat(gl.err, O_RDWR));
      chmod(gl.err, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
    }
    write(1, "\033c", 2);
  } else cb->k_pid = -getpgrp(); /* ȵưϥץ롼 ID  */
  set_ws(WS_ROW1, WS_COL1);
  cb->step = 12;
  if (!gl.curr && !pathname && !check_magic(M_FORK)) gl.ky = 1;
  ioctl(gl.tfd, TCGETS, &gl.text_termio);
  gl.cb_termio = gl.text_termio;
  gl.cb_termio.c_iflag &= ~(BRKINT|PARMRK|INPCK|IUCLC|IXON|IXOFF|ICRNL);
  gl.cb_termio.c_iflag |=  (IGNBRK|IGNPAR);
  gl.cb_termio.c_oflag &= ~(ONOCR);
  gl.cb_termio.c_lflag &= ~(ICANON|ECHO|ECHOE|ECHOK|ECHONL|NOFLSH|ISIG);
  gl.cb_termio.c_lflag |= (FLUSHO);
  gl.cb_termio.c_cc[VMIN] = 0;
  gl.cb_termio.c_cc[VTIME] = 0;
  ioctl(gl.tfd, TCSETSW, &gl.cb_termio);	
  ioctl(gl.tfd, KDSKBMODE, K_RAW);
  ioctl(gl.tfd, KDSETMODE, KD_GRAPHICS);
  vraminit(0, init.font); 
  cb->tty = get_vactive();
  set_magic(M_ACTIVE);
  layer_disp(0); /* ɽ */
  layer_mode(3);
  cb->l_pid = M_ACTIVE;
  if (!(i = fork())) /* ץ fork */
    fork_cat(pathname);
  else cb->c_pid = i;
  pid_str(gl.c_str, cb->c_pid);
  signal(SIGTERM, term_key);
  signal(SIGSEGV, segv_key);
  signal(SIGCLD, SIG_IGN);
  signal(SIGQUIT, SIG_IGN);
  signal(SIGINT, SIG_IGN);
  keyin(pathname);
}

void exit_cb(char *echo)/*cb*/
{
  int kd_mode;

  cb->magic = 0;
  if (cb->r_pid) { /* cb -c ץˤ /tmp/fifo.cb  */
    char r_str[24];
    pid_str(r_str, cb->r_pid);
    if (check_proc(r_str) == 1) kill(cb->r_pid, SIGCONT);
    kill(cb->r_pid, SIGALRM);
    while (check_proc(r_str) >= 0) usleep(10000);
  }
  cb->k_pid = 0;
  ioctl(gl.tfd, KDGETMODE, &kd_mode);
  if (kd_mode == KD_GRAPHICS) {
    ioctl(gl.tfd, TCSETSW, &gl.text_termio);
    ioctl(gl.tfd, KDSKBMODE, K_XLATE);
    layer_mode(2);
    if (cb->vf.jmp != 1) set_vgamode(0);
    ioctl(gl.tfd, KDSETMODE, KD_TEXT);
  }
  if (cb->c_pid && check_proc(gl.c_str) >= 0) {
    /* ץ heap  */
    do {
      if (cb->d_pid > 0) { /* ե륢 */
	if ((cb->d_pid = -cb->d_pid) != -1)
	  kill(-cb->d_pid, SIGKILL); /*  */
      } else if (cb->delay) 
	cb->f.flow = cb->button = cb->vf.busy = cb->delay = 0;
      else continue;
      while (!check_proc(gl.c_str)) usleep(10000); /* suspend Ԥ */
    } while (0);
    if (check_proc(gl.c_str)) /* suspend  */
      kill(cb->c_pid, SIGCONT);
  }
  if (cb->l_pid) kill(cb->l_pid, SIGKILL);
  do {
    if (!gl.curr) {
      gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)] = 0;
      unlink(gl.fifo[0]);
      unlink(gl.fifo[1]);
      if (!gl.old) continue;
    }
    set_conspal();
  } while (0);
  if (init.font) munmap((caddr_t)init.font, ANK_SIZE);
  if (gl.fb) munmap((caddr_t)gl.fb, VRAM_SIZE);
  if (gl.ffd) close(gl.ffd);
  if (gl.kfd) close(gl.kfd);
  close(gl.tfd);
  do {
    if (!gl.curr) {
      if (!gl.old) system("fmpal -r");
      if (!cb->vf.jmp) {
	write(1, echo, strlen(echo));
	continue;
      }
    } else if (!cb->vf.jmp) continue;
    switch(cb->vf.jmp) {
    case 1:
      fprintf(stderr, "cb: %s%s%s\n", "\033[31m", cb->pathname, "\033[m");
      break;
    case 2:
      if (!*cb->pathname)
	fprintf(stderr, "cb: %skeyin(char *pathname)%s: Segmentation fault\n",
		"\033[31m", "\033[m");
      else
	fprintf(stderr, "cb: %s%s%s\n", "\033[31m", cb->pathname, "\033[m");
      break;
    case 3:
      fprintf(stderr, "cb: %s%s%s: Segmentation fault\n", 
	      "\033[31m", cb->pathname, "\033[m");
      break;
    }
  } while (0);
  shmdt((char*)cb);
  shmctl(init.shmid, IPC_RMID, 0);
  set_vactive(init.cons);
  exit(0);
}  

void check_dev(char *strdev, int mode)/*cb*/
{
  int fd;

  if ((fd = open(strdev, mode)) < 0) {
    perror(strdev);
    exit(1);
  }
  close(fd);
}

int check_proc(char *procname)/*cb*/
{
  FILE *proc;
  static char str[80], *cp;

  if ((proc = fopen(procname, "r")) == NULL) /* ץʤ */
    return -1;
  cp = fgets(str, 80, proc);
  fclose(proc);
  if (!cp) return -2;
  str[40] = 0;
  if (tabchrstr(str, 0, " Z ")) /* <zombie> */ 
    return -3;
  if (tabchrstr(str, 0, " T ")) /* suspend */
    return 1;
  return 0;
}

void palette(int f, char *pal)/*cb*/
{
  static char pal0[3*16], pal1[3*16];

  if (pal) {
    if (!f) {
      layer_prior(0x28);
      set_palvec(0, 16, pal);
      layer_prior(0x08);
      set_palvec(0, 16, pal);
    } else memcpy(pal, pal0, 3*16);
  } else if (f) {
    layer_prior(0x08);
    get_palvec(0, 16, pal0);
    layer_prior(0x28);
    get_palvec(0, 16, pal1);
  } else {
    layer_prior(0x28);
    set_palvec(0, 16, pal1);
    layer_prior(0x08);
    set_palvec(0, 16, pal0);
  }
}

void conf(void)/*cb*/
{
  char str[4];
  int i;

  if (ioctl(0, 0x4b70, gl.err) < 0) gl.old = 1; /* 0x4b70 : GIO_CMAP */
  gl.ws = WS;
  gl.editor = EDITOR;
  gl.kanjimode = KANJIMODE;
  for (i = 0; i < 2; i++) {
    strcpy(gl.fifo[i], TMP);
    strcat(gl.fifo[i], it_fifo[i]);
  }
  gl.uid = getuid();
  sprintf(str, "%3x", VERSION);
  memcpy(&it_version[6], str, 3);
  memcpy(&it_err[3], str, 3);
  strcpy(gl.err, TMP);
  strcat(gl.err, it_err);
  gl.version = it_version;
  gl.config = it_config;
  gl.ctrl = CODE;
  gl.note = it_note;
  gl.help = it_help;
  gl.wid = WID;
}

void break_loop(void)/*cb*/
{
  gl.loop = -gl.loop*8;
}

void calib_loop(void)/*cb*/
{
  static volatile unsigned char loop;

  signal(SIGCLD, (__sighandler_t)break_loop);
  /* SIGCLD ȯ break_loop(Υ롼׷¬) */
  gl.loop = 0;
  if (!fork()) {
    sleep(1);
    exit(0); 	/* SIGCLD  */
  }  
  while (gl.loop++ >= 0) while (loop++) ;
  wait(NULL);
}

