#include "cb.h"
#include "key.h"
static char ky_line[128];
void read_vfkey(void)/*cb*/
{
  int c, y, k_n, key;
  unchar *kp = NULL;

#if 1
  cb->x = cb->xo = 311-16;
#else
  cb->x = cb->xo = 1+cb->ws.col*8/2-16;
#endif
  cb->y = cb->yo = (cb->y < MY+2) ? MY+2 : cb->y;
  draw_idle();
  for (y = key = 0; cb->vf.key; key = 0) {
    printtime(0);
    if (!*ky.comm && (c = poll_key(500000)))
      if (!cb->ky.k_n) {
	if (c == 2) ;/* ޥư֥󥯲 */
	else blink();
	continue;
      }
    if (*ky.comm && !kp) {
      kp = ky.comm;
      key = 0;
    }
    if (kp)
      if (*kp) {
	key = mask_key(key)|*kp++;
	wait_susp();
      } else {
	*ky.comm = 0;
	kp = NULL;
	continue;
      }
    else if (cb->f.macro == 3 && ky.up) {
      if (!key && !(key = *ky.up++)) ky.up = NULL;
      wait_susp();
    } else {
      switch(cb->ky.k_n) {
      case K_CANSEL:
      case K_CR:
      case K_f:
	key = ky.tab[cb->ky.k_n];
	break;
      default:
	break;
      }
      if (cb->ky.k_n) cb->ky.k_n = 0;
      if (!key && (key = read_key(ky.tfd)) && cb->f.macro == 1) {
	if (ky.up == ky.macro + 255) {
	  *ky.up = 0;
	  cb->f.macro = 0;
	} else *ky.up++ = key;
      }
      if (!key) continue;
    }
    printtime(0);
    k_n = tabchrstr(ky.tab, key, TABI)-1;
    switch(k_n) {
    case K_DL:
      if (cb->ky.i) {
	if (!cb->ky.f) blink();
	cb->ky.x -= 8;
	cb->ky.i--;
	vramprintf(get_fb1(cb->ky.x, cb->ky.y), ky.bs, ky.bs+1, 1, J_UP);
	vrampaint(cb->ky.x, cb->ky.y, cb->ky.x+8, cb->ky.y+16, 1, V_SET, 0);
	blink();
	key = 0;
      }
      if (!cb->ky.i && cb->y < MY+2) {
	if (!cb->ky.f) blink();
#if 1
	cb->x = 311-16;
#else
	cb->x = 1+cb->ws.col*8/2-16;
#endif
	cb->y = y;
	draw_idle();
	blink();
      } else if (!cb->ky.i && !cb->ky.f) blink();
      break;
    case K_CR:
      cb->x -= 2;
      cb->ky.str[cb->ky.i] = 0;
      cb->vf.key = 0;
      if (cb->y >= MY+2) {
	if ((cb->event = read_pos(cb->x, cb->y))) {
	  cb->f.right = 0;
	  send_sig();
	}
      } else {
	clear_sel();
	cb->push = cb->event = E_CR;
	draw_button(N_PUSH, 1);
	send_sig();
      }
      break;
    case K_CANSEL:
      *cb->ky.str = 0;
      if (cb->y < MY+2) clear_sel();
      cb->event = N_SEL;
      send_sig();
      cb->vf.key = 0;
      break;
    case K_UP:
    case K_DN:
    case K_KUP:
    case K_KDN:
      if (cb->ky.i) continue;
      if (!cb->ky.f) blink();
      key = move_row(k_n, 0);
      break;
    default:
      if (key >= 0x20 && key < 0x7f) {
	if (cb->ky.x+8 >= cb->ws.x-32) continue;
	cb->ky.str[cb->ky.i] = mask_ctl(key);
	if (!cb->ky.f) blink();
	cb->ky.i++;
	if (cb->ky.i == 1) {
	  y = cb->y;
	  cb->x = cb->ws.x - 26;
	  cb->y = 8;
	  draw_idle();
	}
	cb->ky.x += 8;
	blink();
	vramprintf(get_fb1(cb->ky.x-8, cb->ky.y), &cb->ky.str[cb->ky.i-1], 
		   &cb->ky.str[cb->ky.i], 1, J_UP);
	vrampaint(cb->ky.x-8, cb->ky.y, cb->ky.x, cb->ky.y+16, 1, V_SET, 0);
	if (cb->ky.x >= cb->ws.x-32) cb->ky.x -= 8;
	key = 0;
      }
      break;
    }
  }
}

void init_blink(void)/*cb*/
{
  ky.x = cb->ky.x;
  cb->ky.i = cb->ky.f = 0;
  *cb->ky.str = 0;
  init_color(9, gl.convdata);
  blink();
}

void blink(void)/*cb*/
{
  uint *addr;
  int i;

  addr = get_fb1(cb->ky.x, cb->ky.y+1);
  for (i = 0; i < 15; i++) {
    *addr ^= 0x88888880;
    addr += 0x200/sizeof(uint);
  }
  cb->ky.f = !cb->ky.f;
}

void fork_cb(void)/*cb*/
{
  int fd, c, shmid;

  if (fork()) return;
  if ((shmid = shmget(IPC_CB+gl.curr, SHMCB_SIZE, 0666)) < 0)
    if ((shmid = shmget(IPC_CB+gl.curr, SHMCB_SIZE, IPC_CREAT|0666)) < 0) {
      /* IPC_CB ¾ΥץǻѤƤ */
      perror("IPC_CB");
      exit(1);
    }  
  cb = (CB*)shmat(shmid, 0, 0);
  cb->s_pid = -getpgrp();
  strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], itoa(gl.curr));
  cb->magic = 0;
  unlink(gl.fifo[0]);
  mknod(gl.fifo[0], 010777, 0);
  set_magic(M_FORK|M_INIT);
  fd = open(gl.fifo[0], O_WRONLY);
  while (1) {
    c = read(fileno(stdin), ky_line, 128);
    write(fd, ky_line, c);
    if (!c) break;
  }
  c = EOF;
  write(fd, &c, 4); /* ɸϤʤץ(stdin)ǥϥ */
  close(fd);
  shmdt((char*)cb);
  exit(0);
}

int poll_key(int usec)/*cb*/
{
  fd_set readfds;
  struct timeval tv;
  struct mouse_event me;
  
  tv.tv_sec = 0;
  tv.tv_usec = usec;
  FD_ZERO(&readfds);
  FD_SET(ky.tfd, &readfds);
  FD_SET(ky.mfd, &readfds);
  if (select(ky.mfd+1, &readfds, NULL, NULL, &tv) < 0) return 1;
  if (FD_ISSET(ky.mfd, &readfds)) {
    if (ky.f.null) {
      read(ky.mfd, &me, sizeof(struct mouse_event));
      return 3;
    }
    if (read_mouse(ky.mfd)) return 2;
  } else if (!FD_ISSET(ky.tfd, &readfds)) return 1;
  return 0;
}

void printtime(int f)/*cb*/
{
  static char str[256], tmp[256];
  uint *addr, *base;
  int i;

  if (!cb->magic || cb->f.off || cb->f.ff) return;
  init_color(9, gl.convdata);
  get_time(str, 0);
  if (!f && !strcmp(str, tmp)) return; /* 郎ѤäƤʤ */
  vramprintf(get_addr1(cb->bar+402, 0, ky.bf), str, str+9, 9, J_UP);
  vrampaint(cb->bar+402, 0, cb->ws.x-6, 15, 4, V_SET, (int)ky.bf);
  base = get_addr1(cb->bar+402, 32-5, gl.fb);
  addr = get_addr1(cb->bar+402, 0, ky.bf);
  for (i = 0; i < 15; i++) {
    memcpy(base, addr, (cb->ws.x-6-(cb->bar+402))/2);
    base += LINE_LWORDS;
    addr += LINE_LWORDS;
  }  
  strcpy(tmp, str);
}

void toesc(int dummy)/*cb*/
{
  signal(SIGQUIT, toesc);
  ky.comm[0] = EC;
  ky.comm[1] = 0;
}

int loop(int usec)/*cb*/
{
  int key, k_n = 0;

  if (!cb->vf.wait && !cb->vf.in && ++ky.f.count) usleep(usec);
  else
    /* 8  loop() ϥå(poll_key ƤӽФХإåɲ) */
    do {
      if (!poll_key(10000)) {
	key = read_key(ky.tfd);
	k_n = tabchrstr(ky.tab, key, TABI)-1;
	switch(k_n) {
	case K_LT:
	case K_KLT:
	  lt_col();
	  break;
	case K_RT:
	case K_KRT:
	  rt_col();
	  break;
	case K_UP:
	case K_KUP:
	  up_row();
	  break;
	case K_DN:
	case K_KDN:
	  dn_row();
	  break;
	case K_CR:
	case K_f:
	  clear_delay();
	  draw_idle();
	  break;
	case K_SUSP:
	  go_cons(cb->cons);
	  break;
	}
      }
      printtime(0);
      if (cb->ky.k_n == K_SUSP) {
	cb->ky.k_n = 0;
	go_cons(cb->cons);
      }
      usec -= 10000;
    } while (usec);
  if (cb->vf.in) printtime(0);
  if (k_n == K_CANSEL || cb->ky.k_n == K_CANSEL) {
    cb->ky.k_n = 0;
    clear_delay();
    if (!cb->vf.in) draw_idle();
    return 1;
  }
  return 0;
}

void lt_col(void)/*cb*/
{
  cb->x -= (cb->y >= MY) ? 16 : 8;
  draw_idle();
}

void rt_col(void)/*cb*/
{
  cb->x += (cb->y >= MY) ? 16 : 8;
  draw_idle();
}

void prev_row(void)/*cb*/
{ /*  */
  if (cb->vf.busy || !cb->pn.pos) return;
  cb->event = E_UP;
  send_sig();
  return;
}

void up_row(void)/*cb*/
{ /*  */
  int rline;

  if (cb->y < MY+cb->rline) {
    cb->y = MY+2;
    if (!cb->vf.busy) {
      if (!cb->pn.pos) {
	draw_idle();
	return;
      }  
      cb->event = E_UP;
      send_sig();
     return;
    }  
  } else {
    rline = (cb->f.flow) ? 16 : cb->rline;
    if ((cb->y -= rline) < MY+rline) cb->y = MY+2;
  }
  get_event(); /* for [< >] */
}

void next_row(void)/*cb*/
{ /* Լ */
  if (cb->vf.busy) return;
  if (cb->pn.pos >= cb->rpos) {
    if (cb->s_pid) {
      cb->input = 1;
      send_sig();
      wait_susp();
      if (cb->pn.pos >= cb->rpos) return;
    } else return;
  }
  cb->event = E_DN;
  send_sig();
}

void dn_row(void)/*cb*/
{ /* Լ */
  int rline;

  if (cb->y >= cb->ws.row*cb->rline-4) {
    cb->y = cb->ws.row*cb->rline-4;
    if (cb->vf.busy) return;
    if (!cb->s_pid && cb->pn.pos >= cb->rpos) return;
    if (cb->s_pid) {
      cb->input = 1;
      send_sig();
    }
    if (cb->pn.pos >= cb->rpos) {
      draw_idle();
      return;
    }
    cb->event = E_DN;
    send_sig();
    return;
  } else {
    rline = (cb->f.flow) ? 16 : cb->rline;
    cb->y += (cb->y >= MY) ? rline : rline/2;
  }
  get_event(); /* for [< >] */
}

int move_row(int k_n, int ctl)/*cb*/
{
  switch(k_n) {
  case K_CS:
    cb->x = 0;
    draw_idle();
    return 0;
    break;
  case K_CE:
    cb->x = cb->ws.x-24;
    draw_idle();
    return 0;
    break;
  case K_RT:
  case K_KRT:
    rt_col();
    return 0;
    break;
  case K_LT:
  case K_KLT:
    lt_col();
    return 0;
    break;
  case K_EC:
    return ky.tab[K_EC1];
    break;
  case K_NEXT:
  case K_SCn:
    next_row();
    return 0;
  case K_DN:
  case K_KDN:
    dn_row();
    return 0;
    break;
  case K_PREV:
  case K_SCp:
    prev_row();
    return 0;
  case K_UP:
  case K_KUP:
    up_row();
    return 0;
    break;
  case K_KNEXT:
  case K_SPC:
    clear_delay();
    if (cb->f.lack) cb->y = MY+cb->pn.nline*cb->rline-cb->rline*2;
    else 
      do {
	if (cb->pn.pos >= cb->rpos) {
	  if (cb->c_f == C_PIPE && cb->s_pid && cb->in.fd) {
	    cb->input = cb->ws.row-3;
	    send_sig();
	    wait_susp();
	  } else continue;
	}
	cb->event = E_NEXT;
	send_sig();
	wait_susp();
      } while (0);
    draw_idle();
    return 0;
    break;
  case K_KPREV:
  case K_b:
    clear_delay();
    if (cb->f.lack) cb->y = MY+2;
    else if (cb->pn.pos) {
      cb->event = E_PREV;
      send_sig();
      wait_susp();
    }
    return 0;
    break;
  case K_CLEAR:
    cb->event = E_CLEAR;
    send_sig();
    return 0;
    break;
  case K_FORW:
  case K_BACK:
    if (cb->f.lack) {
      draw_idle();
      return 0;
    }
    cb->x = cb->ws.x-24;
    if (!cb->f.flow) {
      cb->y = MY+BORDER;
      cb->push = E_SCROLL;
      draw_button(N_PUSH, 1);
      usleep(200000);
      draw_button(N_PULL, 1);
    }
    if (k_n == K_BACK) {
      if (!cb->pn.pos) return 0;
      if (cb->f.flow == 3) cb->y = 2*(MY+BORDER) - cb->y;
      else if (cb->y == MY+BORDER) cb->y += 8;
      if (cb->y > cb->ws.row*cb->rline-4) cb->y = cb->ws.row*cb->rline-4;
      cb->f.flow = 3;
      cb->s_f = S_FORW;
    } else {
      if (cb->pn.pos >= cb->rpos) {
	if (cb->s_pid) {
	  cb->input = 1;
	  send_sig();
	  wait_susp();
	} else return 0;
      }
      if (cb->f.flow == 2) cb->y = 2*(MY+BORDER) - cb->y;
      else if (cb->y == MY+BORDER) cb->y -= 8;
      cb->f.flow = 2;
      cb->s_f = S_BACK;
    }
    cb->delay = USEC*8;
    get_event();
    send_sig();
    return 0;
    break;
  case K_HEAD:
  case K_TAIL:
    move_pos(k_n);
    return 0;
    break;
  default:
    if (tabchrstr(ky.first, ky.tab[k_n], NULL))
      return ky.tab[k_n]<<8;
    return 0;
    break;
  }
  return ky.tab[k_n];
}  
  
void move_pos(int k_n)/*cb*/
{
  switch(cb->c_f) {
  case C_DU:
  case T_DU:
#if 1
    cb->x = 223-16;
#else
    cb->x = 65+cb->ws.col*8/3-16;
#endif
    break;
  case C_MENU:
  case C_CRT:
  case C_TTY:
  case C_PAL:
  case C_SYS0:
  case C_SYS1:
  case C_HELP:
  case C_LIST:
#if 1
    cb->x = 183-16;
#else
    cb->x = 1+cb->ws.col*8/4-16;
#endif
    break;
  case C_LFILE:
  case C_LDIR:
  case C_BROW:
  case C_GREP:
  case T_GREP:
#if 1
    cb->x = 311-16;
#else
    cb->x = 1+cb->ws.col*8/2-16;
#endif
    break;
  case C_DIR:
#if 1
    cb->x = 435-16;
#else
    cb->x = 266+cb->ws.col*8/4-16;
#endif
    break;
  case C_TAR:
  case C_LHA:
  case C_UNZIP:
#if 1
    cb->x = 327-16;
#else
    cb->x = 154+cb->ws.col*8/3-16;
#endif
    break;
  default:
    cb->x = cb->ws.x-80;
    break;
  }
  cb->push = (k_n == K_HEAD) ? E_HEAD : E_TAIL;
  draw_button(N_PUSH, 1);
  usleep(200000);
  draw_button(N_PULL, 1);
  do {
    if (cb->push == E_HEAD) {
      cb->y = MY+2;
      if (!cb->pn.pos) continue;
    } else {
      if ((cb->y = (cb->f.lack) ? 
	   MY+cb->pn.nline*cb->rline-cb->rline*2 : cb->ws.row*cb->rline-4) < 
	  MY+2)
	cb->y = MY+2;
      if (cb->f.lack || (!cb->s_pid && cb->pn.pos >= cb->rpos))
	continue;
    }
    cb->event = cb->push;
    send_sig();
    wait_susp();
  } while (0);
  draw_idle();
}

void wait_cont(void)/*cb*/
{
  int f = 0;

  if (cb->f.pin) return;
  do {
    if (f) usleep(10000);
    else if ((f = loop(10000))) cansel(0);
  } while (check_proc(gl.c_str));
}

void wait_susp(void)/*cb*/
{
  int f = 0;

  if (cb->f.pin) return;
  do {
    if (f) usleep(10000);
    else if ((f = loop(10000))) cansel(0);
  } while (!check_proc(gl.c_str));
}

void flush_key(int tfd)/*cb*/
{
  int j;

  ky.f.null = 1;
  while ((j = poll_key(10000)) != 1) if (!j) read_key(tfd);
  ky.f.null = 0;
}

void jump_cb(int magic, char *pathname)/*cb*/
{ /* magic ѿ cb üڤؤ */
  int fd, c;

  cb->cons = get_vactive(); /* ü¸ (CTRLZ ) */
  switch(magic) {
  case M_FILE:
    if (*pathname == '/') strcpy(cb->pathname, pathname);
    else { /* path ˥եѥ */
      getcwd(gl.pathname, 256);
      strcat(gl.pathname, "/");
      strcat(gl.pathname, pathname);
      strcpy(cb->pathname, gl.pathname);
    }
    cb->s_pid = 0;
    if (get_vactive() == 7) {
      set_vactive(8);
      set_magic(M_FILE|M_INIT);
    } else {
      set_magic(M_FILE|M_INIT|M_TTY);
      while (check_magic(M_TTY)) usleep(10000);
    }
    shmdt((char*)cb);
    exit(0);
    break;
  case M_PIPE:
    signal(SIGCONT, cbcont);
    signal(SIGTSTP, SIG_DFL);
    signal(SIGTERM, SIG_DFL);
    *cb->pathname = 0;
    cb->s_pid = getpgrp();
    strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], itoa(cb->s_pid));
    unlink(gl.fifo[0]);
    mknod(gl.fifo[0], 010777, 0);
    read(0, &c, 1);
    if (get_vactive() == 7) {
      set_vactive(8);
      set_magic(M_PIPE|M_INIT);
    } else {
      set_magic(M_PIPE|M_INIT|M_TTY);
      while (check_magic(M_TTY)) usleep(10000);
    }
    fd = open(gl.fifo[0], O_WRONLY);
    write(fd, &c, 1);
    do {
      c = read(0, ky_line, 128);
      write(fd, ky_line, c);
    } while (c == 128);
    c = EOF;
    write(fd, &c, 4); /* ɸϤʤץ(stdin)ǥϥ */
    close(fd);
    while (!access(gl.fifo[0], F_OK)) { /* ץԤ( del_cont) */
      kill(-cb->s_pid, SIGTSTP);
      usleep(5);
    }
    break;
  }  
}

void cbcont(int dummy)/*cb*/
{ /* job  fore-ground  */
  int pid;

  signal(SIGCONT, cbcont);
  if (!cb->k_pid) {
    shmdt((char*)cb);
    exit(1);
  }
  if (access(gl.fifo[0], F_OK) < 0) {
    pid = cb->s_pid;
    cb->s_pid = 0;
    shmdt((char*)cb);
    kill(-pid, SIGTERM);
    exit(0);
  }
  if (cb->vf.wait || cb->delay) 
    fprintf(stderr, "cb: Can't access cb\n");
  else {
    cb->vf.stop = 1;
    cb->s_pid = getpgrp();
    if (get_vactive() == 7) {
      set_magic(M_PIPE);
      set_vactive(8);
    } else set_magic(M_PIPE|M_TTY);
  }
}

