#include "cb.h"
#include "cat.h"
static struct {
  CHILD *t;
  int cld;
  struct stat st;
  unchar str[10000];
  unchar tmp[10000];
} m;
void malloc_list(BASE *base, LIST *list)/*cb*/
{ /* list ¤Τ */
  int row;
  PP *pp;

  row = 1;
  pp = &base->pp[1];
  pp = malloc_l(list, pp, &row);
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  base->nline = row;
}  

PP *malloc_l(LIST *list, PP *pp, int *rowp)/*cb*/
{
  if (list) {
    int i;
    pp = malloc_l(list->left, pp, rowp);
    if ((i = tabchrstr(list->name, '(', NULL)) != 0) list->name[i-2] = 0;
    if (cb->ff.grep || list->name[1] == ' ' || (!i && list->name[3] == ')') ||
	stat(&list->name[1], &m.st) >= 0) {
      if (i) list->name[i-2] = ' ';
      pp->next = (PP*)calloc(sizeof(PP), 1);
      pp->next->prev = pp;
      pp = pp->next;
      pp->str = malloc(strlen(list->name)+2);
      strcpy(pp->str, list->name);
      strcat(pp->str, "\n");
      pp->cs = pp->str;
      pp->ce = pp->cs + strlen(pp->cs);
      (*rowp)++;
    } else if (i) list->name[i-2] = ' ';
    pp = malloc_l(list->right, pp, rowp);
  }  
  return pp;
}

void malloc_cgrep(BASE *base)/*cb*/
{
  int row;
  PP *pp;
  CHILD *chp;
  LIST *list;
  
  for (chp = (get_child(NULL, "egrep", NULL))->next; chp; chp = chp->next) 
    if (!strcmp(chp->argv[1], "egrep")) break;
  list = NULL;
  for (; chp; chp = chp->next) 
    list = save_list(list, chp->argv[3], cb->pn, NULL);
  row = 1;
  pp = &base->pp[1];
  pp = malloc_l(list, pp, &row);
  free_list(list);
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  base->nline = row;
}

void malloc_tgrep(BASE *base)/*cb*/
{
  PP *pp;
  int i, j, k, row, size, tell, kanji, pv[2], pv2[2];
  char *end, *cp, *ce, str[128];
  CHILD *chp;

  tell = 0;
  chp = get_child(NULL, "egrep", cb->ky.str);
  for (cp = cat.pat; *cp;  cp++) if (strchr(cb->ky.str, *cp)) break;
  pipe(pv2);
  if (!(i = fork())) {
    pipe(pv);
    if (!fork()) {
      BASE *bp;
      close(fileno(stdout));
      dup2(pv[1], 1);
      close(pv[0]);
      close(pv[1]);
      bp = (cb->s_pid) ? cat.bi : cat.bp;
      for (pp = bp->pp->next->next; pp->next && pp != &bp->pp[2]; 
	   pp = pp->next)
	if (pp->ce == &pp->cs[cb->ff.bs]) /* '\n' Ƭ */
	  fputc('\n', stdout);
	else {
	  fwrite(&pp->cs[cb->ff.bs], 1, pp->ce-pp->cs-cb->ff.bs, stdout);
	  if (pp->cs[pp->ce-pp->cs-1] != '\n')  /* Ԥü */
	    fputc('\n', stdout);
	}
      exit(0);
    }
    dup_log();
    close(fileno(stdin));
    close(fileno(stdout));
    dup2(pv[0], 0);
    dup2(pv2[1], 1);
    close(pv2[0]);
    close(pv2[1]);
    close(pv[0]);
    close(pv[1]);
    if (!*cp) {
      i = tabchrstr(chp->argv[0], 0, "egrep");
      chp->argv[0][i-1] = chp->argv[1][0] = 'f';
    }
    execv(chp->argv[0], &chp->argv[1]);
    wait(0);
    exit(0);
  } else cb->d_pid = i;
  close(fileno(stdin));
  dup2(pv2[0], 0);
  close(pv2[0]);
  close(pv2[1]);
  row = 1;
  pp = &base->pp[1];
  ce = str;
  j = k = 0;
  size = malloc_text(base, stdin);
  wait(NULL);
  if (cb->d_pid < 0) {
    clear_base(base);
    return;
  } else cb->d_pid = 0;
  size = init_type(&base->text, size, &kanji, T_GREP);
  end = base->text + size;
  for (cp = (char*)base->text; cp < end; ) {
    if (j > 10 && !k) {
      for (k = 0; str[k] != ':' && k < 10; k++) ;
      if (k == 10) k = 0;
    }	
    if ((i = *ce++ = *cp++) != '\n') {
      if (j < cb->ws.col + k) {
	j++;
	continue;
      }
      *ce = 0;
      while (*cp++ != '\n') ;
    } else *ce = 0;
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    if ((i = tabchrstr(str, ':', NULL) - 1) < 0) {
      i = 0;
      str[i+1] = 0;
      pp->tell = tell;
    } else {
      str[i] = 0;
      tell = pp->tell = (atoi(str)-1)*16;
    }
    str[i] = ' ';
    pp->cs = pp->str = strdup(&str[i]);
    pp->ce = pp->cs + strlen(&str[i]);
    pp->kanji = J_EUC;
    j = k = 0;
    ce = str;
    row++;
  }
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  free(base->text);
  base->text = NULL;
  base->nline = row;
}  

int malloc_cut(BASE *base, int size, char *cs, CHILD *chp)/*cb*/
{ /* ֥饦ɽʬ */
  int i, pv[2], pv2[2];

  pipe(pv2);
  if (!(i = fork())) {
    pipe(pv);
    if (!fork()) {
      close(fileno(stdout));
      dup2(pv[1], 1);
      close(pv[0]);
      close(pv[1]);
      fwrite(cs, 1, size, stdout);
      exit(0);
    }
    dup_log();
    close(fileno(stdin));
    close(fileno(stdout));
    dup2(pv[0], 0);
    dup2(pv2[1], 1);
    close(pv2[0]);
    close(pv2[1]);
    close(pv[0]);
    close(pv[1]);
    execv(chp->argv[0], &chp->argv[1]);
    wait(0);
    exit(0);
  } else i = cb->d_pid;
  close(fileno(stdin));
  dup2(pv2[0], 0);
  close(pv2[0]);
  close(pv2[1]);
  size = malloc_text(base, stdin);
  wait(0);
  if (cb->d_pid < 0) {
    clear_base(base);
    size = 0;
  } else cb->d_pid = 0;
  return size;
}  

void malloc_tar(BASE *base)/*cb*/
{
  int i, j;
  char *dp, *cp, *ce, str[128];
  PP *pp, *pt;
  
  cp = base->text;
  pt = cat.base[8+cb->ff.shift].pp[1].next;
  pp = &base->pp[1];
  pp->next = (PP*)calloc(sizeof(PP), 1);
  pp->next->prev = pp;
  pp = pp->next;
  while (1) {
    ce = dp = cp;
    for (j = 0; pt->str[j] != '\n'; j++) ;
    while ((i = tabchrstr(cp, '/', NULL))) {
      dp = cp;
      cp = &cp[i];
    }
    pp->str = strdup((pt->str[j-1] == '/') ? dp : cp);
    pp->cs = pp->str;
    pp->kanji = J_ANK;
    cp = ce + 512;
    pp->tell = (int)cp;
    j = pp->cut = pt->cut;
    while (j--) cp++; /* ե륵ʬݥ󥿤ʤ */
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    if ((pt = pt->next) == &cat.base[8+cb->ff.shift].pp[2]) break;
    ptcpy(str, &pt->cs[20]);
    i = strlen(str); /* ե륵Ĺʹߤ˽񤭤ޤƤ */
    while (strncmp(cp, str, i)) cp++; /* ⤷ʤԤ򥹥å */
  }  
  pp = pp->prev;
  free(pp->next);
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
}

void malloc_lha(BASE *base, CHILD *chp)/*cb*/
{
  int i, j, pv[2];
  char *ce;
  char *dp, *cp, str[128];
  PP *pp, *pt;
  
  pipe(pv);
  if (!(i = fork())) {
    dup_log();
    close(fileno(stdout));
    dup2(pv[1], 1);
    close(pv[1]);
    close(pv[0]);
    execl(chp->argv[0], "lha", "p", chp->argv[chp->argc], NULL);
  } else cb->d_pid = i;
  close(fileno(stdin));
  dup2(pv[0], 0);
  close(pv[0]);
  close(pv[1]);
  base->size = malloc_text(base, stdin);
  wait(NULL);
  if (cb->d_pid < 0) {
    clear_base(base);
    return;
  } else cb->d_pid = 0;
  cp = base->text;
  pt = cat.base[8+cb->ff.shift].pp[1].next;
  pp = &base->pp[1];
  pp->next = (PP*)calloc(sizeof(PP), 1);
  pp->next->prev = pp;
  pp = pp->next;
  while (1) {
    for (j = 0; pt->str[j] != '\n'; j++) str[j] = pt->str[j];
    str[j] = 0;
    if (str[j-1] == '/') { /* ǥ쥯ȥ̾ξ */
      for (ce = cp, dp = cp = &str[20]; (i = tabchrstr(cp, '/', NULL)); ) {
	dp = cp;
	cp = &cp[i];
      }
      pp->str = strdup(dp);
      cp = ce;
    } else {
      while (*cp++ != '\n') ;
      for (j = 0; cp[j] != '\n'; j++) ;
      cp[j] = 0;
      while ((i = tabchrstr(cp, '/', NULL))) cp = &cp[i];
      for (i = 0; ; i++) if (!(str[i] = *cp++)) break;
      pp->str = strdup(str);
      for (; *cp++ != '\n'; ) ;
    }
    pp->cs = pp->str;
    pp->kanji = J_ANK;
    pp->tell = (int)cp;
    j = pp->cut = pt->cut;
    while (j--) cp++;
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    if ((pt = pt->next) == &cat.base[8+cb->ff.shift].pp[2]) break;
  }  
  pp = pp->prev;
  free(pp->next);
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
}

void malloc_unzip(BASE *base, CHILD *chp)/*cb*/
{
  int i, j, pv[2];
  char *ce;
  char *cp, *dp, str[128];
  PP *pp, *pt;
  
  pipe(pv);
  if (!(i = fork())) {
    dup_log();
    close(fileno(stdout));
    dup2(pv[1], 1);
    close(pv[1]);
    close(pv[0]);
    execl(chp->argv[0], "unzip", "-p", chp->argv[chp->argc], NULL);
  } else cb->d_pid = i;
  close(fileno(stdin));
  dup2(pv[0], 0);
  close(pv[0]);
  close(pv[1]);
  base->size = malloc_text(base, stdin);
  wait(NULL);
  if (cb->d_pid < 0 || !base->size) {
    clear_base(base);
    return;
  } else cb->d_pid = 0;
  cp = base->text;
  pt = cat.base[8+cb->ff.shift].pp[1].next;
  pp = &base->pp[1];
  pp->next = (PP*)calloc(sizeof(PP), 1);
  pp->next->prev = pp;
  pp = pp->next;
  while (1) {
    for (j = 0; pt->str[j] != '\n'; j++) str[j] = pt->str[j];
    str[j] = 0;
    if (str[j-1] == '/') { /* ǥ쥯ȥ̾ξ */
      for (ce = cp, dp = cp = &str[20]; (i = tabchrstr(cp, '/', NULL)); ) {
	dp = cp;
	cp = &cp[i];
      }
      pp->str = strdup(dp);
      cp = ce;
    } else {
      ce = &str[20];
      while ((i = tabchrstr(ce, '/', NULL))) ce = &ce[i];
      for (i = 0; ; i++) if (!(str[i] = *ce++)) break;
      pp->str = strdup(str);
    }
    pp->cs = pp->str;
    pp->kanji = J_ANK;
    pp->tell = (int)cp;
    j = pp->cut = pt->cut;
    while (j--) cp++;
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    if ((pt = pt->next) == &cat.base[8+cb->ff.shift].pp[2]) break;
  }  
  pp = pp->prev;
  free(pp->next);
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
}

void malloc_help(BASE *base)/*cb*/
{
  int pv[2], pv2[2];
  CHILD *chp;
  
  chp = get_child(NULL, "egrep", "");
  chp->argv[2][1] = 'b';
  pipe(pv2);
  if (!fork()) {
    pipe(pv);
    if (!fork()) {
      close(fileno(stdout));
      dup2(pv[1], 1);
      close(pv[1]);
      close(pv[0]);
      fwrite(cat.help, 1, strlen(cat.help), stdout);
      exit(0);
    }
    dup_log();
    close(fileno(stdin));
    close(fileno(stdout));
    dup2(pv[0], 0);
    dup2(pv2[1], 1);
    close(pv2[0]);
    close(pv2[1]);
    close(pv[0]);
    close(pv[1]);
    execv(chp->argv[0], &chp->argv[1]);
    wait(0);
    exit(0);
  } 	
  close(fileno(stdin));
  dup2(pv2[0], 0);
  close(pv2[0]);
  close(pv2[1]);
  chp->argv[2][1] = 'n';
  base->nline = malloc_pp(C_HELP, base);
}

int malloc_file(int c_f, BASE *base, CHILD *chp)/*cb*/
{ /* ɽ⡼ɤ˱ base ¤Τ */

  int i, pv[2], kanji = J_ANK;
  
  do {
    switch(c_f) {
    case C_FILE:
    case C_CUT:
      base->size = 
	init_type(&base->text, base->size, &kanji, c_f);
      continue;
    case C_DU:
      setpathname(NULL, cat.work[W_DU]);
      break;
    default:
      break;
    }
    pipe(pv);
    if (!(i = fork())) {
      dup_log();
      signal(SIGSEGV, (__sighandler_t)send_segv);
      close(fileno(stdout));
      dup2(pv[1], 1);
      close(pv[1]);
      close(pv[0]);
      execv(chp->argv[0], &chp->argv[1]);
    } else cb->d_pid = i;
    close(fileno(stdin));
    dup2(pv[0], 0);
    close(pv[0]);
    close(pv[1]);
    if (c_f == C_BIN && (!strcmp(chp->argv[1], "zcat") ||
			 !strcmp(chp->argv[2], "-man"))) {      
      base->size = malloc_text(base, stdin);
      wait(NULL);
      if (cb->d_pid < 0) {
	clear_base(base);
	return J_ANK;
      } else cb->d_pid = 0;
      base->size = init_type(&base->text, base->size, &kanji, C_BIN);
    } else {
      base->nline = malloc_pp(c_f, base);
      return J_ANK;
    }
  } while (0);
  base->nline = cut_text(base, kanji);
  return kanji;
}

int malloc_pp(int c_f, BASE *base)/*cb*/
{
  int i, j, k, row, tell, kanji;
  char *cp, *ce, *end, str[256];
  PP *pp;

  tell = 0;
  stat(gl.pathname, &m.st);
  if (!m.st.st_size) save_log("cb: %s: No size\n", gl.pathname);
  j = 0;
  k = (c_f == C_DIR) ? 20 : 0; /* 20: ե륻쥯ɽǤκʸ-1 */
  row = 1;
  pp = &base->pp[1];
  if (c_f == C_DIR) fgets(str, 256, (FILE*)stdin);
  base->size = malloc_text(base, stdin);
  wait(0);
  if (cb->d_pid < 0) {
    clear_base(base);
    return 0;
  } else cb->d_pid = 0;
  if (c_f == C_HELP || c_f == C_DIR) kanji = J_EUC;
  else base->size=init_type(&base->text, base->size, &kanji, c_f);
  if (!base->size && c_f == C_BROW) 
    save_log("cb: %s: No string matched\n", gl.pathname);
  cp = base->text;
  end = base->text + base->size;
  for (ce = str; cp < (char*)end; ) {
    if ((c_f == C_BROW || c_f == C_HELP) && j > 10 && !k) {
      for (k = 0; str[k] != ':' && k < 10; k++) ;
      if (k == 10) k = 0;
    }	
    if ((i = *ce++ = *cp++) != '\n') {
      if (j < cb->ws.col + k) {
	j++;
	continue;
      }
      *ce = 0;
      while (*cp++ != '\n') ;
    } else *ce = 0;
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    switch(c_f) {
    case C_DIR:	
      j -= 21;
      memcpy(&str[10], &str[31], j);
      i = 0;
      break;
    case C_BROW:
    case C_HELP:
      if ((i = tabchrstr(str, ':', NULL) - 1) < 0) {
	i = 0;
	str[i+1] = 0;
	pp->tell = tell;
      } else {
	str[i] = 0;
	tell = pp->tell = atoi(str);
      }
      str[i] = ' ';
      break;
    default:
      i = 0;
      break;
    }	
    pp->cs = pp->str = strdup(&str[i]);
    pp->ce = pp->cs + strlen(&str[i]);
    pp->kanji = kanji;
    j = 0;
    k = (c_f == C_DIR) ? 20: 0;
    ce = str;
    row++;
  }
  if (c_f == C_DIR && row == 48) {
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    pp->cs = pp->str = strdup(pp->prev->str);
    pp->ce = pp->cs + strlen(pp->prev->str);
    pp->kanji = J_ANK;
  }
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  if (c_f == C_BROW) pp->next->tell = m.st.st_size;
  else if (c_f == C_HELP) pp->next->tell = strlen(cat.help);
  if (base->text) {
    free(base->text);
    base->text = NULL;
  }
  return row;
}

int cut_text(BASE *base, int kanji)/*cb*/
{
  char *cs;
  int i, j, k, f, row;
  unchar *cu, *end;
  PP *pp;

  pp = &base->pp[1];
  cs = base->text;
  end = (unchar*)cs + base->size;
  for (cu = cs, i = k = f = 0, row = 1; cu < end; ) {
    if (*cu == '\t') 
      for (j = 7 - (i & 7); j && i < cb->ws.col; j--, i++) ;
    if (*cu == '_') {
      if (cu[1] == BS) {
	f = 2;
	cu += f;
	continue;
      } else if (cu[1] == '_' && cu[2] == BS && cu[3] == BS) {
	f = 4;
	cu += f;
	continue;
      }
    } else if (*cu == BS) {
      if (cu[1] == BS) {
	f = 4;
	cu += f;
      } else {
	f = 2;
	cu += f; 
      }
      continue;
    }
    if (i < cb->ws.col && kanji == J_EUC) {
      if (is_euckana_1_byte(cu[0]) && is_euckana_2_byte(cu[1])) {
	k++;
	cu++;
	continue;
      }
      if (!is_euc_1_byte(*cu) && (*cu != '\t' || (*cu == '\t' && k % 2))) 
	k++; /* Ⱦʸ */
    }
    if (*cu == '\n' || i == cb->ws.col) {
      pp->next = (PP*)calloc(sizeof(PP), 1);
      pp->next->prev = pp;
      pp = pp->next;
      pp->cs = cs;
      if ((j = *cu == '\n')) {
	cs = cu + 1;
	if ((pp->ce = (char*)cu) < pp->cs) pp->ce = pp->cs;
	cu--;
      } else if (f) {
	cu -= f;
	if ((pp->ce = (char*)cu) < pp->cs) pp->ce = pp->cs;
	cs = cu;
	f = 0;
      } else {
	if (k % 2) cu--; /* Ǵʬ */
	cs = cu;
	cu--;
	if ((pp->ce = (char*)cu) < pp->cs) pp->ce = pp->cs;
      }
      cu = cs-1;
      i = -1;
      k = 0;
      row++;
    }
    i++;
    cu++;
  }
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  return row;
}

PP *malloc_pipe(BASE *base, PP *pp)/*cb*/
{
  int c, i, j, f, k, len, kanji, n_tab;
  unchar *cs, *cu, *end;
  CONT *cont;
  
  if (!pp) {
    if (cb->ff.arc) cb->ff.arc = 0;
    strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], 
	   itoa((gl.curr) ? gl.curr : cb->s_pid));
    cb->in.fd = fopen(gl.fifo[0], "r");
    pp = &base->pp[1];
    cat.row = 1;
  } else if (!cb->in.i) return pp;
  else if (cb->in.i < 0) {
    if (!++cb->in.i) cb->push = -1; /* [ |! ]  */
    cat.row++;
    cb->pn.nline = base->nline = cat.row-3;
    if (!(cat.dx = cb->bar * (cb->ws.row-2) / cb->pn.nline)) cat.dx++;
    if (!gl.curr) {
      cont = get_cont(cat.cont, cb->s_pid);
      cont->fd = cb->in.fd;
    }
    return pp;
  }
  do {
    if ((i = linein(cb->in.fd)) == EOF) {
      strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], 
	     itoa((gl.curr) ? gl.curr : cb->s_pid));
      fclose(cb->in.fd);
      if (cat.row >= cb->ws.rrow) {
	pp = pp->prev;
	if (pp->next->str) free(pp->next->str);
	free(pp->next);
	cb->in.i = -2;
	if (!gl.curr) {
	  cont = get_cont(cat.cont, cb->s_pid);
	  cont->fd = cb->in.fd;
	}
      } else {
	cb->push = -1;
	cb->in.i = 0;
	if (!gl.curr) {
	  cont = get_cont(cat.cont, cb->s_pid);
	  cont->fd = cb->in.fd;
	}
      }
      break;
    }
    kanji = i;
    end = m.str + strlen(m.str)+1;
    for (cu = cs = m.str, i = k = f = n_tab = 0; cu < end; ) {
      c = *cu;
      if (c == '\t') 
	for (j = 7 - (i & 7); j && i < cb->ws.col; j--, i++, n_tab++) ;
      if (kanji != J_BIN) {
	if (cu < end-1) {
	  if (c == '_') {
	    if (cu[1] == BS) { /* */
	      f = 2;
	      cu += f;
	      continue;
	    } else if (cu < end-3 && 
		       cu[1] == '_' && cu[2] == BS && cu[3] == BS){
	      f = 4;
	      cu += f;
	      continue;
	    }
	  } else if (c == BS) {
	    if (cu[1] == BS) {
	      f = 4;
	      cu += f;
	    } else {
	      f = 2;
	      cu += f; 
	    }
	    continue;
	  }
	  if (i < cb->ws.col) {
	    if (is_euckana_1_byte(cu[0]) && is_euckana_2_byte(cu[1])) {
	      k++;
	      cu++;
	      continue;
	    }
	    if (!is_euc_1_byte(*cu) && (*cu != '\t' || (*cu == '\t' && k%2))) 
	      k++; /* Ⱦʸ */
	  }
	}
      }
      if ((j = (cu == end-1 || *cu == '\n')) || i == cb->ws.col) {
	pp->next = (PP*)calloc(sizeof(PP), 1);
	pp->next->prev = pp;
	pp = pp->next;
	if (i == cb->ws.col) {
	  len = cb->ws.col - n_tab - k % 2 - j;
	  pp->str = malloc(len + 1);
	  memcpy(pp->str, cs, len);
	  pp->str[len] = 0;
	  cu = cs + len - 1;
	  if (j) j = 0;
	} else {
	  pp->str = strdup(cs);
	  if ((len = (int)cu - (int)cs - 2) < 0) len = 0;
	}
	pp->cs = pp->str;
	pp->kanji = kanji;
	pp->ce = &pp->cs[len]+1;
	cs = cu + 1;
	i = -1;
	k = n_tab = 0;
	cat.row++;
	if (j) break;
      }
      i++;
      cu++;
    }
  } while (0);
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  cb->pn.nline = base->nline = cat.row;
  if (!(cat.dx = cb->bar * (cb->ws.rrow+2) / cb->pn.nline)) cat.dx++;
  cb->rpos = ((i = cb->pn.nline - cb->ws.rrow) > 0) ? i * cb->rline : 0;
  return pp;
}

void malloc_head(int c_f, BASE *base, CHILD *chp)/*cb*/
{
  int i, j, k, row, pv[2];
  char *end, *cs, *ce, str[256], d_str[24];
  char *cp;
  PP *pp;
  FILE *fd;
  
  row = 1;
  pp = &base->pp[1];
  if (c_f == C_TAR && 
      (tabchrstr(chp->ext, 'z', NULL) ||
      tabchrstr(chp->ext, 'Z', NULL))) {
    chp = get_child(NULL, "zcat", gl.pathname);
    pipe(pv);
    if (!(i = fork())) {
      dup_log();
      close(fileno(stdout));
      dup2(pv[1], 1);
      close(pv[0]);
      close(pv[1]);
      execv(chp->argv[0], &chp->argv[1]);
    } else cb->d_pid = i;
    close(fileno(stdin));
    dup2(pv[0], 0);
    close(pv[0]);
    close(pv[1]);
    cat.base[4+cb->ff.shift].size = malloc_text(NULL, stdin);
    wait(&j);
    if (j || cb->d_pid < 0) {
      clear_base(base);
      return;
    } else cb->d_pid = 0;
    strcpy(&gl.fifo[0][tabchrstr(gl.fifo[0], '_', NULL)], itoa(0));
    unlink(gl.fifo[0]);
    mknod(gl.fifo[0], 010777, 0);
    chp = get_child(".tar", "tar", gl.fifo[0]);
    j = 1;
  } else j = base->size = 0;
  pipe(pv);
  if (!(i = fork())) {
    dup_log();
    close(fileno(stdout));
    dup2(pv[1], 1);
    close(pv[1]);
    close(pv[0]);
    execv(chp->argv[0], &chp->argv[1]);
  } else cb->d_pid = i;
  pid_str(d_str, cb->d_pid);
  close(fileno(stdin));
  dup2(pv[0], 0);
  close(pv[0]);
  close(pv[1]);
  switch(c_f) {
  case C_TAR:
    if (j) {
      j = 0;
      m.cld = (int)signal(SIGCLD, (__sighandler_t)free_mt);
      if (!fork()) {
	CHILD *tp;
	fd = fopen(gl.fifo[0], "w");
	for (tp = m.t; tp; tp = tp->next) fwrite(tp->ext, 1, tp->argc, fd);
	fclose(fd);
	exit(0);
      }
    }
    break;
  case C_LHA:
    if (cb->d_pid > 0)
      for (i = 0; i < 2; i++) 
	fgets(str, 256, (FILE*)stdin);
    break;
  case C_UNZIP:
    if (cb->d_pid > 0)
      do {
	if (!fgets(str, 256, (FILE*)stdin)) {
	  clear_base(base);
	  return;
	}
      } while (strncmp(str, " --", 3));
    break;
  }
  j = 0;
  if ((i = check_proc(d_str)) < 0) wait(&j);
  if (cb->d_pid < 0 || j) {
    clear_base(base);
    return;
  } else cb->d_pid = 0;
  base->size = malloc_text(base, stdin);
  if (i >= 0) wait(0);
  cp = base->text;
  end = base->text + base->size;
  k = 0;
  for (ce = str; cp < (char*)end; ) {
    if ((i = *ce++ = *cp++) != '\n') {
      if (j < 127) {
	j++;
	continue;
      }
      *ce = 0;
      while (*cp++ != '\n') ;
    } else *ce = 0;
    pp->next = (PP*)calloc(sizeof(PP), 1);
    pp->next->prev = pp;
    pp = pp->next;
    switch(c_f) {
    case C_TAR:
      for (ce = str; *ce != '/'; ce++) ;
      for (i = 0; i < 5; i++) {
	while (*ce != ' ') ce++; 
	while (*ce == ' ') ce++;
	if (!i) {
	  for (k = pp->cut = 0; *ce != ' '; ce++) {
	    if (*ce == ',') pp->cut = -1; /* ǥХե */
	    else if (!pp->cut) k = k * 10 + *ce - '0';
	  }
	  ce++;
	}
      }
      break;
    case C_LHA:
      for (ce = str, i = 0; *ce != '\x25' && *ce != '*' && i < 40; i++) 
	ce++;
      if (i == 40) {
	pp = pp->prev;
	free(pp->next);
	cp = end;
	continue;
      }
      cs = ce;
      for (i = 0; i < 4; i++) {
	while (*ce != ' ') ce++;
	while (*ce == ' ') ce++;
      }
      cs++;
      for (i = 0; i < 2; i++) {
	while (*cs == ' ') cs--;
	while (*cs != ' ') cs--;
      }
      cs++;
      for (k = 0; *cs != ' '; cs++) k = k * 10 + *cs - '0';
      break;
    case C_UNZIP:
      for (cs = str; *cs == ' ' && *cs != '-'; cs++) ;
      if (*cs == '-') {
	pp = pp->prev;
	free(pp->next);
	cp = end;
	continue;
      }
      for (k = 0; *cs != ' '; cs++) k = k * 10 + *cs - '0';
      for (ce = cs, i = 0; i < 2; i++) {
	while (*ce == ' ') ce++;
	if (!i) memcpy(str, ce, 9);
	while (*ce != ' ') ce++;
      }
      while (*ce == ' ') ce++;
      break;
    }
    if (pp->cut < 0) k = 0; /* no size */ 
    sprintf(&str[9], "%10d ", k);
    pp->cut = k;
    cs = &str[20];
    while ((*cs = *ce++) != '\n' && *cs) cs++;
    if (*cs) *++cs = 0;
    pp->cs = pp->str = strdup(str);
    pp->ce = pp->cs + strlen(str);
    pp->kanji = J_ANK;
    j = 0;
    ce = str;
    row++;
  }
  pp->next = &base->pp[2];
  base->pp[2].prev = pp;
  if (base->text) {
    free(base->text);
    base->text = NULL;
  }
  if (c_f == C_LHA && row < 2) {
    free_base(base);
    clear_base(base);
    return;
  }
  base->nline = row;
}

CHILD* malloc_t(CHILD *tp, int *sizep, FILE *fd)/*cb*/
{
  if (!tp) {
    tp = (CHILD *)malloc(sizeof(CHILD));
    tp->ext = malloc(T_SIZE);
    tp->argc = fread(tp->ext, 1, T_SIZE, fd);
    *sizep += tp->argc;
    if (tp->argc == T_SIZE) tp->next = malloc_t(NULL, sizep, fd);
    else tp->next = NULL;
  }
  return tp;
}

int malloc_text(BASE *base, FILE *fd)/*cb*/
{
  CHILD *tp;
  int size;
  char *cp;

  size = 0;
  m.t = malloc_t(NULL, &size, fd);
  if (!base) return size;
  if ((base->text = malloc(size)) == NULL) {
    clear_base(base);
    size = 0;
  } else if (size)
    for (tp = m.t, cp = base->text; tp; cp += tp->argc, tp = tp->next) 
      memcpy(cp, tp->ext, tp->argc);
  free_t(m.t);
  return size;
}

void free_t(CHILD *t)/*cb*/
{
  CHILD *tp;
  do {
    tp = t->next;
    free(t->ext);
    free(t);
    t = tp;
  } while (t);
}

void free_mt(void)/*cb*/
{
  BASE *bp = &cat.base[4+cb->ff.shift];
  char *cp;
  CHILD *tp;

  signal(SIGCLD, (__sighandler_t)m.cld);
  bp->text = malloc(bp->size);
  for (tp = m.t, cp = bp->text; tp; cp += tp->argc, tp = tp->next)
    memcpy(cp, tp->ext, tp->argc);
  free_t(m.t);
  wait(0);
}

void send_segv(void)/*cb*/
{
  kill(getppid(), SIGSEGV);
}

int sjistoeuc2(int size)/*cb*/
{ /* ɤ SJIS  EUC Ѵ */
  int i, eucsize;
  uint p, q;

  for (i = eucsize = 0; i < size; ) {
    if ((p = m.str[i]) == '\r') {
      i++;
      continue;
    }
    if (is_sjis_1_byte(p)) {
      q = m.str[i+1];
      p = (p << 1) -((p > 0x9f) ? 0x161 : 0xe1);
      if (q < 0x9f) q = q - ((q > 0x7f) ? 0x20 : 0x1f);
      else {
	q = q - 0x7e;
	p++;
      }
      m.tmp[eucsize] = p | 0x80;
      m.tmp[eucsize+1] = q | 0x80;
      eucsize += 2;
      i += 2;
    } else if (is_sjiskana(p)) {
      m.tmp[eucsize] = 0x8e;
      m.tmp[eucsize+1] = p;
      eucsize += 2;
      i++;
    } else {
      m.tmp[eucsize] = p;  
      i++;
      eucsize++;
    }
  }
  memcpy(m.str, m.tmp, eucsize);
  return eucsize;
}

int init_kanji(int *size_p, char **text_p, int c_f)/*cb*/
{
  int kn[4];
  int i, j, kanji, jis, c1, c2, c3, count, binary, size;
  unchar *start;
  char *text = *text_p;

  start = (unchar*)text;
  size = *size_p;
  kanji = J_ANK;
  c3 = 0;
  jis = size >= 8;
  count = size-1;
  for (i = 0; i < 4; i++) kn[i] = 0;
  for (i = binary = 0; i < count; i++) {
    if ((c1 = start[0]) < SB && c1 && !tabchrstr(gl.ctrl, c1, NULL)) /*binary*/
      binary = 1;
    c2 = start[1];
    if (jis) c3 = start[2];
    if (is_sjiskana(c1)) kn[3]++; /* Ⱦѥʸ */
    if ((is_euckana_1_byte(c1) && is_euckana_2_byte(c2)) ||
	(is_euc_1_byte(c1) && is_euc_2_byte(c2))) {
      kn[1]++;
      start++;
      i++;
      if (is_sjiskana(c2)) kn[3]++; /* ʸ³Ⱦѥʤؤн */
    } else if (is_sjis_1_byte(c1) && is_sjis_2_byte(c2)) {
      kn[0]++;
      start++;
      i++;
    } else if (jis && c1 == EC)
      if ((c2 == '$' && (c3 == 'B' || c3 == '@')) ||
	  (c2 == '(' && (c3 == 'B' || c3 == 'J'))) {
	kn[2]++;
	start += 2;
	i += 2;
      }
    start++;
  }
  for (i = j = 0, kanji = J_ANK; i < 3; i++)
    if (kn[i] > j) {
      j = kn[i];
      kanji = cat.kc[i];
    }
  if (gl.file == 2 && binary)
    kanji = J_ANK; /*  .gz ե */
  else if (gl.file != 2 && binary) {
    if (cb->ff.cld && c_f == C_FILE) { /* C_CUT  */
      if (cb->ff.arc) /* Хʥ */
	text = info_pipe(text, size);
      else text = info_file(text, gl.pathname);
      if (text) {
	size = strlen(text);
	*text_p = text;
	kanji = J_ANK;
      }
    }
  }
  if (kanji == J_SJIS) size += kn[3];
  *size_p = size;
  return kanji;
}

int init_kanji2(int *size_p)/*cb*/
{
  int kn[6];
  int i, j, kanji, jis, c1, c2, c3, count, binary, size;
  unchar *start;

  c1 = c3 = 0;
  size = *size_p;
  start = m.str;
  kanji = J_ANK;
  jis = size >= 8;
  count = size-1;
  for (i = 0; i < 6; i++) kn[i] = 0;
  for (i = binary = 0; i < count; i++) {
    c1 = start[0];
    if (c1 < SB && c1 && !tabchrstr(gl.ctrl, c1, NULL)) kn[5]++;
    c2 = start[1];
    if (jis) c3 = start[2];
    if (is_sjis(c1)) kn[4] = 1;
    if (is_sjiskana(c1)) kn[3]++;
    if (is_sjis_1_byte(c1) && is_sjis_2_byte(c2)) {
      kn[0]++;
      start++;
      i++;
    } else if (!kn[4] && 
	       ((is_euckana_1_byte(c1) && is_euckana_2_byte(c2)) ||
		(is_euc_1_byte(c1) && is_euc_2_byte(c2)))) {
      kn[1]++;
      start++;
      i++;
    } else if (!kn[4] && jis && c1 == EC)
      if ((c2 == '$' && (c3 == 'B' || c3 == '@')) ||
	  (c2 == '(' && (c3 == 'B' || c3 == 'J'))) {
	kn[2]++;
	start += 2;
	i += 2;
      }
    start++;
  }
  if (kn[4]) kanji = J_SJIS;
  else
    for (i = j = 0, kanji = J_ANK; i < 3; i++)
      if (kn[i] > j) {
	j = kn[i];
	kanji = cat.kc[i];
      }
  if (kn[5]) kanji = J_BIN;
  if (kanji == J_SJIS || kanji == J_JIS) 
    size += kn[3]; /* SJIS or JIS  EUC ѴȾѥʬ */
  *size_p = size;
  return kanji;
}

int linein(FILE *fd)/*cb*/
{
  int  kanji, ret, len;

  do {
    ret = (int)fgets(m.str, 5000, fd);
  } while (ret && !m.str[0]);
  if (!ret) return EOF;
  if ((len = strlen(m.str)-1) && m.str[len-1] == '\r') 
    len--; /*  CRLF */ 
  if (len < 0) len = 0;
  m.str[len++] = '\n';
  m.str[len] = 0;
  ret = '\n';
  if ((kanji = init_kanji2(&len)) == J_SJIS)
    len = sjistoeuc2(len);
  else if (kanji == J_JIS) len = jistoeuc(m.str, len);
  m.str[len] = 0;
  return kanji;
}

void print_pp(BASE *base)/*cb*/
{
  PP *tp;
  static int f;

  if (f) return;
  for (tp = base->pp[1].next; tp->next; tp = tp->next) {
    fprintf(stderr, "***");
    fwrite(tp->cs, 1, tp->ce-tp->cs+1, stderr);
    fprintf(stderr, "***\n");
  }
  f = 1;
}  

void filter(void)/*cb*/
{
  setsid(); /* cb -c Υʥ */
  while (linein(stdin) != EOF) fprintf(stdout, "%s", m.str);
  exit(0);
}
