#include "cb.h"
#include "cat.h"

int init_back(int c_f)/*cb*/
{ /* CTRL+G */
  struct stat st;
  int i;
  
  if ((i = c_f) != T_GREP) {
    c_f = load_stack(1);
    if (strcmp(gl.pathname, cat.label[L_PIPE])) susp_stdin(0);
    switch(cb->ff.lb) {
    case E_MENU:
    case E_CRT:
    case E_LIST:
      break;
    default:
      break;
    }
    if (c_f == T_GREP && cat.event != N_SEL) c_f = TT_GREP;
  } else {
    c_f = cb->ky.c_f;
    if (cb->ff.grep == 3) {
      /* 'p'  GREP ޥ */
      if (*cat.work[W_LB]) {
        strcpy(cb->tag, cat.work[W_LB]);
      } else {
        *cb->tag = 0;
      }
    }
    cb->ff.grep = 0;
  }
  cat.event = N_SEL;
  if (c_f != C_CUT && c_f != C_HELP && c_f != T_HELP && c_f != TT_GREP)
    res_vgamode();
  switch(i) {
  case C_MENU:
  case C_CRT:
  case C_LIST:
  case C_CUT:
  case C_FILE: /* ¾ü(stdin)ʳ */
  case C_BIN:  /* θư */
  case C_BROW:
  case C_TAR:
  case C_LHA:
  case C_UNZIP:
    cb->c_f = C_SKIP;
  case C_TTY:
  case C_PAL:
  case C_SYS:
  case C_SYS0:
  case C_SYS1:
  case C_LDIR:
  case C_LFILE:
  case C_LOG:
  case C_DU:
  case T_DU:
    return c_f;
  case T_GREP:
  case C_GREP:
    if (c_f != C_MENU && c_f != C_TTY && c_f != C_PAL && 
	c_f != C_SYS && c_f != C_SYS0 && c_f != C_SYS1) 
      cb->c_f = C_SKIP;
    cb->vf.key = 0;
    cat.tell = -1;
    return c_f;
  case C_PIPE:
  case T_PIPE:
    if (c_f != TT_GREP) {
      gl.wid = cat.pwid;
      if (gl.ws != cat.pws) {
	gl.ws = cat.pws;
	sw_ws(gl.ws);
	layer_disp(0);
	layer_mode(0);
	cb->ky.k_n = K_WS;
	kill(cb->c_pid, SIGTSTP);
      }
      cb->c_f = C_SKIP;
    }
    return c_f;
  case C_HELP:
  case T_HELP:
    if (cat.ws && c_f != TT_GREP) {
      gl.ws = cat.ws = 0;
      sw_ws(0);
      layer_disp(0);
      layer_mode(0);
      cb->ky.k_n = K_WS;
      kill(cb->c_pid, SIGTSTP);
    }
    return c_f;
    break;
  case C_DIR:
    if (c_f == T_GREP || c_f == TT_GREP) return c_f;
    switch(cb->ff.lb) {
    case E_DU:
      c_f = T_DU;
      chdir(cat.work[W_DU]);
      delnl(gl.pathname, cat.work[W_DU]);
      strcpy(cat.work[W_DIR], cat.work[W_DU]);
      break;
    case E_GREP:
      cb->c_f = C_SKIP;
      break;
    default:
      delnl(gl.pathname, cat.work[W_OLD]);
      strcpy(cat.work[W_OLD], cat.work[W_DIR]);
      if (stat(gl.pathname, &st) < 0) setpathname(NULL, gl.pathname);
      chdir(gl.pathname);
      setpathname(NULL, gl.pathname);
      strcpy(cat.work[W_DIR], gl.pathname);
      break;
    }
    break;
  default:
    if (c_f == T_GREP || c_f == TT_GREP) return c_f;
    switch(cb->ff.lb) {
    case E_DU:
      if (c_f == T_DU) {
	chdir(cat.work[W_DU]);
	delnl(gl.pathname, cat.work[W_DU]);
	strcpy(cat.work[W_DIR], cat.work[W_DU]);
      }
      break;
    case E_FILE:
      cb->c_f = C_SKIP;
      break;
    default:
      cb->c_f = C_SKIP;
      setpathname(NULL, gl.pathname);
      chdir(gl.pathname);
      c_f = C_DIR;
      break;
    }
    break;
  }	
  return c_f;
}

int init_mode(int c_f, int event)/*cb*/
{ /* ⡼ɻ(DIR, FILE, WS, du) */
  char *cp;
  int c, i;
  struct stat st;

  if (cb->ff.grep && event == E_GREP) return c_f;
  if (event != E_GREP && event != E_RGREP) res_vgamode();
  i = c_f;
  do {
    switch(event) {
    case E_MENU:
      if (cb->ff.lb && cb->ff.lb != E_DU)  /* [ * ]  [ * ] ¹Ի or */
	while (cb->ff.lb && cb->ff.lb != E_DU) /* CRT, LIST  */
	  c_f = load_stack(1);
      continue;
      break;
    case E_CRT:
    case E_LIST:
      if (cb->ff.lb == E_MENU && !cb->ff.shift)
	while (cb->ff.lb == E_MENU) /* [ * ] ޤǥå POP */
	  c_f = load_stack(1);
      else
	while (cb->ff.lb && cb->ff.lb != E_MENU && cb->ff.lb != E_DU)
	  c_f = load_stack(1);
    default:
      save_stack(c_f);
      if (cb->ff.grep) {
	cb->ff.grep = 0;
	cat.tell = -1;
      }
      break;
    }  
  } while (0);
  switch(event) {
  case E_MENU:
    save_stack((c_f != T_GREP) ? c_f : 0);
    if (*gl.pathname != ' ') {
      strcpy(cb->tag, gl.pathname);
      strcpy(cat.work[W_SYS], gl.pathname);
    }
    if (cb->ff.grep) {
      cb->ff.grep = 0;
      cat.tell = -1;
    }
    c_f = C_MENU;
    delnl(gl.pathname, cat.mode[event].p);
    if (cb->ff.shift) cb->ff.shift = 0;
    break;
  case E_CRT:
    if (cb->ff.grep) {
      cb->ff.grep = 0;
      cat.tell = -1;
    }
    if (*gl.pathname != ' ') strcpy(cb->tag, gl.pathname);
    delnl(gl.pathname, cat.mode[event].p);
    c_f = C_CRT;
    break;
  case E_LIST:
    if (cb->ff.grep) {
      cb->ff.grep = 0;
      cat.tell = -1;
    }
    if (*gl.pathname != ' ') strcpy(cb->tag, gl.pathname);
    delnl(gl.pathname, cat.mode[event].p);
    c_f = C_LIST;
    break;
  case E_DU:
  case E_RDU:
    delnl(gl.pathname, cat.work[W_DIR]);
    while (cat.n_s) load_stack(0);
    clear_flag();
    if (cb->ff.shift) cb->ff.shift = 0;
    if (event == E_RDU) {
      event = E_DU;
      c_f = (cat.base[2].pp[1].next) ? T_DU : C_DU;
      chdir(cat.work[W_DU]);
      delnl(gl.pathname, cat.work[W_DU]);
      strcpy(cat.work[W_DIR], cat.work[W_DU]);
    } else c_f = C_DU;
    *cb->tag = 0;
    break;
  case E_GREP:
  case E_RGREP:
    if (*cb->tag) {
      do {
	switch(cb->ff.lb) {
	case E_DIR:
	  i = C_DIR;
	  c = '\xa0';
	  break;
	case E_FILE:
	  i = C_FILE;
	  c = (tabchrstr(cb->tag, '\xa0', NULL)) ? '\xa0' : 0;
	  break;
	case E_DU:
	  i = C_FILE; /* եޤϥǥ쥯ȥ */
	  c = '.';
	  break;
	default:
	  i = c = 0;
	  continue;
	}
	strcpy(cat.work[W_PATH], cb->tag);
	for (cp = cat.work[W_PATH]; *cp != c; cp++) ;
	while (*cp == '\xa0') cp++;
	stat(cp, &st);
	if (!strcmp(cp, ".")) st.st_mode = S_IFDIR;
	get_filename(i, cat.work[W_PATH]);
	if (cb->ff.lb == E_DU && S_ISDIR(st.st_mode)) 
	  strcat(cat.work[W_PATH], "/");
	strcpy(cb->tag, cat.work[W_PATH]);
      } while (0);
    } else {
      strcpy(cat.work[W_PATH], gl.pathname);
      get_filename(c_f, cat.work[W_PATH]);
      set_lb(cb->ff.lb, cat.work[W_PATH]);
    }
    cat.bp = gl.bp;
    if (cb->ff.lb == E_DU && (c_f == C_DU || c_f == T_DU)) {
      set_lb(E_DU, gl.pathname);
      delnl(gl.pathname, cat.mode[E_DU].p);
    } else if (cb->ff.lb && c_f == C_MENU) {
      set_lb(cb->ff.lb, gl.pathname);
      delnl(gl.pathname, cat.mode[cb->ff.lb].p);
    } else if (c_f == C_CUT) delnl(gl.pathname, cb->tag);
    else { 
      set_lb(0, gl.pathname);
      get_filename(c_f, gl.pathname);
    }  
    for (i = c = 0; i < 20; i++) 
      if (c) gl.pathname[i] = ' ';
      else if (!gl.pathname[i+1]) c = 1;
    gl.pathname[i] = 0;
    if ((cb->ff.grep = (event == E_GREP) ? 1 : 3) == 3)
      strcpy(cat.work[W_LB], gl.pathname); /* gl.pathname[i] ¸ */
    cb->ky.c_f = c_f;
    c_f = C_GREP;
    if (cb->ky.i) cb->ky.i = 0; /* ǽưɽ */
    break;
  default:
    break;
  }
  if (event != E_GREP && event != E_RGREP) cb->ff.lb = event;
  return c_f;
}

int init_dir(int c_f, int event)/*cb*/
{ /* ǥ쥯ȥư */
  int i;
  char *cp;
  
  res_vgamode();
  strcpy(cat.work[W_PATH], gl.pathname);
  while (cat.n_s) load_stack(0);
  clear_flag();
  if (cb->ff.shift) cb->ff.shift = 0;
  delnl(gl.pathname, cat.work[W_PATH]);
  strcpy(cat.work[W_PATH], cat.work[W_DIR]);
  if (*gl.pathname != ' ') strcpy(cat.work[W_DIR], gl.pathname);
  get_dir(gl.pathname);
  strcpy(cat.work[W_DIR], gl.pathname);
  if (event == N_MODE) cat.work[W_DIR][1] = '\0';
  else {
    for (cp = cat.work[W_DIR], i = 0; i < event - N_MODE + 1; i++)
      cp = &cp[tabchrstr(cp, '/', NULL)];
    *--cp = '\0';
  }  
  if (strcmp(cat.work[W_PATH], cat.work[W_DIR])) 
    strcpy(cat.work[W_OLD], cat.work[W_PATH]);
  chdir(cat.work[W_DIR]);
  setpathname(NULL, cat.work[W_DIR]);
  delnl(gl.pathname, cat.work[W_DIR]);
  return C_DIR;
}

int init_select(int c_f, int event)/*cb*/
{ /* ե륻쥯ܼ */
  int i, j, grep, kanji;
  PP *pp;
  char *name, pathname[256], str[80], tty[10];
  char *cp, *dp, color[3*N_PAL];
  CHILD *chp, *chb;
  struct stat st;
  
  switch(c_f) {
  case C_GREP:
    for (i = 0; i < 128; i++) cb->tag[i] = ' ';
    if (event == E_CR) cb->ky.str[cb->ky.i] = 0;
    if (event != E_CR && (cb->button || !*cb->ky.str)) {
      pp = cat.base[5+cb->ff.shift].pp[1].next;
      for (i = 0; i < cb->pn.pos + (event-cb->num)*cb->rline; i += cb->rline) 
	pp = pp->next;
      delnl(cb->ky.str, &pp->cs[1]);
    } else {
      if (event == E_CR) cb->ky.str[cb->ky.i] = 0;
      for (chp = (get_child(NULL, "egrep", NULL))->next; chp; chp = chp->next) 
	if (!strcmp(chp->argv[1], "egrep")) break;
      for (chb = chp; chp; chp = chp->next) {
	if (!strcmp(chp->argv[3], cb->ky.str)) break;
	chb = chp;
      }
      if (!chp) {
	char *tag = malloc(4+strlen(cb->ky.str)+1);
	strcpy(tag, "... ");
	strcat(tag, cb->ky.str);
	if (!cat.new) chb->next = cat.new = save_child(cat.new, tag, 2);
	else save_child(cat.new, tag, 2);
	free(tag);
      }
      cb->vf.wait = 1;
    }
    for (cp = cb->ky.str, i = cb->ky.x-cb->ky.i*8; *cp; cp++) {
      i += 8;
      vramprintf(get_fb1(i-8, cb->ky.y), cp, cp+1, 1, J_UP);
      vrampaint(i-8, cb->ky.y, i, cb->ky.y+16, 1, V_SET, 0);
    }
    if (cb->ff.grep == 3)
      strcpy(pathname, cat.work[W_LB]); /* gl.pathname[i]  */
    grep = cb->ff.grep;
    load_stack(1); /* gl.pathname  */
    if ((cb->ff.grep = grep) == 3) { /* cb->ff.grep  */
      if (*cb->tag) strcpy(cat.work[W_LB], cb->tag);
      else *cat.work[W_LB] = 0;
      strcpy(cb->tag, pathname);
    }
    c_f = T_GREP;
    cb->pn.y = MY+2;
    cb->pn.pos = 0;
    cat.tgrep = save_list(cat.tgrep, cat.label[L_TGREP], cb->pn, NULL);
    if (cb->s_pid && cb->in.fd) {
      cb->vf.in = 1;
      draw_idle();
      do {
	cat.pp = malloc_pipe(cat.bi, cat.pp);
      } while (cb->in.fd && cb->vf.in);
      cb->vf.in = 0;
      draw_idle();
    }
    break;
  case T_GREP:
    pp = cat.base[6+cb->ff.shift].pp[1].next;
    for (i = 0; i < cb->pn.pos + (event - cb->num)*cb->rline; i += cb->rline) 
      pp = pp->next;
    if (cb->ff.grep == 1) {
      save_stack(0);
      for (i = 0; i < 128; i++) cb->tag[i] = ' ';
      i = set_lb(E_GREP, NULL);
      strcpy(&cb->tag[i], &pp->cs[1]);
    } else {
      cb->ff.grep = 2;
      if (*cat.work[W_LB]) strcpy(cb->tag, cat.work[W_LB]);
      else *cb->tag = 0;
    }
    delnl(cat.str, &pp->cs[1]);
    cat.tell = pp->tell;
    c_f = cb->ky.c_f;
    cb->c_f = C_SKIP;
    cat.tgrep = save_list(cat.tgrep, cat.label[L_TGREP], cb->pn, NULL);
    cat.event = event;
    break;
  case C_TAR:
  case C_LHA:
  case C_UNZIP:
    cb->ff.grep = 0;
    cat.tell = -1;
    pp = cat.base[4+cb->ff.shift].pp[1].next;
    for (i = 0; i < cb->pn.pos + (event - cb->num)*16; i += 16) 
      pp = pp->next;
    save_stack(c_f);
    for (i = 0; i < 128; i++) cb->tag[i] = ' ';
    strcpy(cb->tag, pp->cs);
    cb->ff.cld = (cb->f.right) ? 0 : 1;
    free_base(&cat.base[9+cb->ff.shift]);
    cb->vf.wait = 1;
    cb->idle = 4;
    draw_idle();
    is_child(&chp, cb->tag, 1, (char*)pp->tell, pp->cut);
    if (chp && (!strcmp(chp->argv[1], "tar") ||
		!strcmp(chp->argv[1], "lha") ||
		!strcmp(chp->argv[1], "groff") ||
		!strcmp(chp->argv[1], "dvi2tty") ||
		!strcmp(chp->argv[1], "zcat"))) gl.file = 2;/* file ɽ */
    kanji = init_text(&cat.base[9+cb->ff.shift], pp->cut, pp->tell, 
		      &cat.base[9+cb->ff.shift].text, NULL);
    if (gl.file == 2) {
      gl.file = 0;
      if (strcmp(chp->argv[1], "zcat") || pp->cut < gl.z) {
	free_base(&cat.base[3+cb->ff.shift]);
	name = chp->argv[chp->argc];
	chp->argv[chp->argc] = (!strcmp(chp->argv[1], "tar") ||
				!strcmp(chp->argv[1], "lha")) ? "-" : NULL;
	i = malloc_cut(&cat.base[3+cb->ff.shift], pp->cut, 
		       cat.base[9+cb->ff.shift].text, chp);
	chp->argv[chp->argc] = name;
	free_base(&cat.base[9+cb->ff.shift]);
	if (i) {
	  init_text(&cat.base[9+cb->ff.shift], i, 
		    (int)cat.base[3+cb->ff.shift].text, 
		    &cat.base[9+cb->ff.shift].text, NULL);
	} else 
	  clear_base(&cat.base[9+cb->ff.shift]);
      }
    }
    c_f = C_CUT;
    cb->pn.pos = 0;
    cat.cut = save_list(cat.cut, cat.label[L_CUT], cb->pn, NULL);
    break;
  case C_BROW:
  case C_HELP:
    cb->ff.grep = 0;
    cat.tell = -1;
    if (cb->ff.arc) cb->ff.arc = 0;
    cb->ff.cld = 1;
    i = (c_f == C_BROW) ? 0 : 10;
    pp = cat.base[i+cb->ff.shift].pp[1].next;
    for (i = 0; i < cb->pn.pos + (event - cb->num)*cb->rline; i += cb->rline) 
      pp = pp->next;
    save_stack(c_f);
    for (i = 0; i < 128; i++) cb->tag[i] = ' ';
    strcpy(cb->tag, &pp->cs[1]);
    if (c_f == C_BROW) {
      /* cut  0 ȴ */
      free_base(&cat.base[1+cb->ff.shift]);
      if (!pp->tell) pp->tell = -1;
      init_text(&cat.base[1+cb->ff.shift], pp->next->tell-pp->tell, pp->tell, 
		&cat.base[1+cb->ff.shift].text, gl.pathname);
    } else {
      free_base(&cat.base[11+cb->ff.shift]);
      if (!pp->tell) pp->tell = -1;
      init_text(&cat.base[11+cb->ff.shift], pp->next->tell - pp->tell, 
		(int)cat.help+pp->tell,
		&cat.base[11+cb->ff.shift].text, NULL);
    }
    c_f = C_CUT;
    cb->ff.bs = 0;
    cb->pn.pos = 0;
    cat.cut = save_list(cat.cut, cat.label[L_CUT], cb->pn, NULL);
    break;
  case C_MENU:
  case C_TTY:
  case C_SYS:
  case C_SYS0:
  case C_SYS1:
  case C_LDIR:
  case C_LFILE:
    cb->ff.shift = 0;
  case C_LIST:
  case C_CRT:
  case C_PAL:
  case C_WID:
    cb->ff.grep = 0;
    cat.tell = -1;
    pp = gl.bp->pp[1].next;
    for (i = 0; i < cb->pn.pos + (event - cb->num)*16; i += 16) 
      pp = pp->next;
    delnl(str, &pp->cs[1]);
    cp = str;
    if (!tabchrstr(cp, '/', NULL)) dp = NULL;
    else
      for (dp = cp; (i = tabchrstr(cp, '/', NULL)); ) {
	dp = cp;
	cp = &cp[i];
      }
    switch(cb->ff.lb) {
    case E_CRT:
      switch(c_f) {
      case C_CRT:
	for (i = L_WS; cat.label[i] && strcmp(&cp[3], cat.label[i]); i++) ;
	switch(i) {
	case L_WS:
	  if (!cb->s_pid) { /* (stdin) Ǥ WS  */
	    gl.ws = cat.pws = !gl.ws;
	    sw_ws(gl.ws);
	    layer_disp(0);
	    layer_mode(0);
	    cb->ky.k_n = K_WS;
	    kill(cb->c_pid, SIGTSTP);
	    c_f = 0;
	  }
	  do { /* [ * ] ޤǥå POP */
	    c_f = load_stack(1);
	  } while (cb->ff.lb == E_CRT);
	  cb->c_f = C_SKIP;
	  break;
	case L_PAL:
	  save_stack(c_f);
	  c_f = C_PAL;
	  strcpy(cat.work[W_PATH], cb->tag);
	  set_lb(cb->ff.lb, cat.work[W_PATH]);
	  delnl(gl.pathname, cat.label[L_PAL]);
	  break;
	case L_WID:
	  if (cb->s_pid) { /* (stdin) Ǥ WID  */
	    do { /* [ * ] ޤǥå POP */
	      c_f = load_stack(1);
	    } while (cb->ff.lb == E_CRT);
	    cb->c_f = C_SKIP;
	  } else {
	    save_stack(c_f);
	    c_f = C_WID;
	    strcpy(cat.work[W_PATH], cb->tag);
	    set_lb(cb->ff.lb, cat.work[W_PATH]);
	    delnl(gl.pathname, cat.label[L_WID]);
	  }
	  break;
	default:
	  break;
	}
	break;
      case C_PAL:
	if (!load_list(cat.pal, cp, NULL, color)) 
	  save_log("cb: %s: No such palette\n", cp);
	else {
	  for (i = 0; i < 3*N_PAL; i++) cb->color[i] = color[i];
	  layer_mode(3);
	  do { /* [ * ] ޤǥå POP */
	    c_f = load_stack(1);
	  } while (cb->ff.lb == E_CRT);
	  cb->c_f = C_SKIP;
	}
	break;
      case C_WID:
	if (!cb->s_pid) { /* (stdin) Ǥ WID  */
	  gl.wid = cat.pwid = cb->rline = atoi(&cp[4]);
	  sw_ws(gl.ws);
	  layer_disp(0);
	  layer_mode(0);
	}
	do { /* [ * ] ޤǥå POP */
	  c_f = load_stack(1);
	} while (cb->ff.lb == E_CRT);
	cb->c_f = C_SKIP;
	break;
      }
      break;
    case E_LIST:
      switch(c_f) {
      case C_LIST:
	for (i = L_LDIR; cat.label[i] && strcmp(&cp[3], cat.label[i]); i++) ;
	save_stack(c_f);
	strcpy(cat.work[W_PATH], cb->tag);
	set_lb(cb->ff.lb, cat.work[W_PATH]);
	switch(i) {
	case L_LDIR:
	  delnl(gl.pathname, cat.label[L_LDIR]);
	  c_f = C_LDIR;
	  break;
	case L_LFILE:
	  delnl(gl.pathname, cat.label[L_LFILE]);
	  c_f = C_LFILE;
	  break;
	}
	break;
      case C_LDIR:
	cb->ff.dir = 1;
	set_lb(cb->ff.lb, NULL);
	strcat(cb->tag, dp);
	cp = &pp->cs[1];
	delnl(gl.pathname, cp);
	if (strcmp(cat.work[W_DIR], gl.pathname)) 
	  strcpy(cat.work[W_OLD], cat.work[W_DIR]);
	chdir(gl.pathname);
	setpathname(NULL, gl.pathname);
	strcpy(cat.work[W_DIR], gl.pathname);
	while (cat.n_s) load_stack(0); /* dir ѤΤǥå */
	clear_flag();
	c_f = C_DIR;
	break;
      case C_LFILE:
	set_lb(cb->ff.lb, NULL);
	strcat(cb->tag, cp);
	delnl(pathname, &pp->cs[1]);
	if ((i = tabchrstr(pathname, 0, " (")) != 0) pathname[i-1] = 0;
	strcpy(gl.pathname, pathname);
	strcpy(cat.work[W_OLD], cat.work[W_DIR]);
	strcpy(cat.work[W_DIR], gl.pathname);
	get_dir(cat.work[W_DIR]);
	free_base(&cat.base[7]);
	chdir(cat.work[W_DIR]); /* ǥ쥯ȥư˺ */
	malloc_file(C_DIR, &cat.base[7], 
		    get_child(NULL, "ls", cat.work[W_DIR]));
	while (cat.n_s) load_stack(0); /* dir ѤΤǥå */
	clear_flag();
	cb->ff.cld = (i) ? 1 : 0; /* POP ˥ե饰å */
	c_f = C_FILE;
	break;
      }
      break;
    case E_MENU:
      switch(c_f) {
      case C_MENU:
	for (i = L_HELP; cat.label[i] && strcmp(&cp[3], cat.label[i]); i++) ;
	save_stack(c_f);
	delnl(gl.pathname, cat.label[i]);
	switch(i) {
	case L_HELP:
	  c_f = (cb->f.right) ? T_HELP : C_HELP;
	  if (!gl.ws) {
	    cat.ws = 1;
	    gl.ws = 1;
	    sw_ws(1);
	    layer_disp(0);
	  }
	  break;
	case L_TTY:
	  c_f = C_TTY;
	  break;
	case L_LOG:
	  c_f = C_LOG;
	  break;
	case L_SYS:
	  c_f = C_SYS;
	  break;
	case L_SYS0:
	  c_f = C_SYS0;
	  break;
	case L_SYS1:
	  c_f = C_SYS1;
	  break;
 	case L_SPC:
	  c_f = 0;
	  break;
	case L_EXIT:
	  free_cat();
	  break;
	}
	set_lb(cb->ff.lb, NULL);
	break;
      case C_TTY:
	strcpy(tty, &cat.label[L_tty][1]);
	for (i = 1; i <= 9; i++) {
	  tty[4] = i + '0';
	  if (tabchrstr(cp, 0, tty)) break;
	}
	cb->f.cons = (i == 10) ? cb->tty : i;
	susp_stdin(1);
	break;
      case C_SYS:
	for (i = L_SYS0; cat.label[i] && strcmp(&cp[3], cat.label[i]); i++) ;
	strcpy(cat.work[W_PATH], cb->tag);
	set_lb(cb->ff.lb, cat.work[W_PATH]);
	switch(i) {
	case L_SYS0:
	  save_stack(c_f);
	  c_f = C_SYS0;
	  delnl(gl.pathname, cat.label[L_SYS0]);
	  break;
	case L_SYS1:
	  save_stack(c_f);
	  c_f = C_SYS1;
	  delnl(gl.pathname, cat.label[L_SYS1]);
	  break;
	}
	break;
      case C_SYS0:
	delnl(cb->errormes, cp);
	cb->ky.k_n = K_SC_PF+9;
	kill(cb->c_pid, SIGTSTP);
	break;
      case C_SYS1:
	delnl(cb->errormes, cp);
	strcat(cb->errormes, " ");
	strcat(cb->errormes, cat.work[W_SYS]);
	cb->ky.k_n = K_SC_PF+9;
	kill(cb->c_pid, SIGTSTP);
	break;
      default:
	break;
      }
    }
    break;
  case C_DIR:
  case C_DU:	
  case T_DU:	
    if (c_f == C_DIR) strcpy(cat.work[W_DIR], gl.pathname);
    save_stack(c_f);
    cb->ff.grep = 0;
    cat.tell = -1;
    if (cb->ff.lb == E_DIR) strcpy(cb->tag, gl.pathname);
    pp = gl.bp->pp[1].next;
    for (i = 0; i < cb->pn.pos + (event - cb->num)*16; i += 16) 
      pp = pp->next;
    if (c_f == C_DU || c_f == T_DU) {
      for (i = 0; i < 128; i++) cb->tag[i] = ' ';
      i = set_lb(cb->ff.lb, NULL);
      delnl(cb->tag, pp->cs);
    }  
    i = 2;
    if (c_f == C_DIR) {
      if (cb->ff.lb == E_DU) strcpy(cb->tag, gl.pathname);
      cp = &pp->cs[34];
    } else {
      if ((cp = &pp->cs[tabchrstr(pp->cs, '.', NULL)+1]) > pp->ce) cp = pp->ce;
      i++;
    }  
    memcpy(gl.pathname, cp, pp->ce - cp + i);
    gl.pathname[(j = tabchrstr(gl.pathname, '\n', NULL)) ? 
		j-1 : pp->ce-cp+i] = 0;
    if (!strcmp(gl.pathname, "//")) strcpy(gl.pathname, "/");
    cp = gl.pathname;
    if (tabchrstr(cp, ' ', NULL)) { /* for symlink */
      for (i = strlen(gl.pathname); i && *cp != ' '; i--) cp++;
      *cp = '\0';
    } else if (tabchrstr(cp, '*', NULL)) {
      for (i = strlen(gl.pathname); i && *cp != '*'; i--) cp++;
      *cp = '\0';
    }
    if ((i = stat(gl.pathname, &st)) >= 0 && S_ISDIR(st.st_mode)) {
      if (i < 0) setpathname(NULL, gl.pathname);
      chdir(gl.pathname);
      setpathname(NULL, gl.pathname);
      if (strcmp(cat.work[W_DIR], gl.pathname)) {
	strcpy(cat.work[W_PATH], gl.pathname);
	if ((cb->ff.lb == E_DU || cb->ff.lb == E_DIR) && 
	    !cb->ff.dir) cb->ff.dir = 1;
	else {
	  while (cat.n_s) load_stack(0); /* dir ѤΤǥå */
	  clear_flag();
	}
	delnl(gl.pathname, cat.work[W_PATH]);
	strcpy(cat.work[W_OLD], cat.work[W_DIR]);
	strcpy(cat.work[W_DIR], gl.pathname);
      }
      c_f = C_DIR;
    } else {
      if (cb->ff.dir) {
	while (cat.n_s) load_stack(0);
	clear_flag();
      }
      cb->ff.cld = (cb->f.right) ? 0 : 1;
      setpathname(gl.pathname, gl.pathname);
      c_f = C_FILE;
    }  
    break;
  }
  return c_f;
}  
  
void set_tag(char *work)/*cb*/
{
  if (*work) strcpy(cb->tag, work);
  else *cb->tag = 0;
}

void save_stack(int c_f)/*cb*/
{
  STACK *sp;

  sp = cat.stack[cat.n_s] = (STACK*)calloc(1, sizeof(STACK));
  sp->tag = strdup(cb->tag);
  sp->pathname = strdup(gl.pathname);
  sp->w_dir = strdup(cat.work[W_DIR]);
  sp->w_old = strdup(cat.work[W_OLD]);
  if (!c_f) {
    c_f = T_GREP;
    sp->ky_str = strdup(cb->ky.str);
    sp->ky_c_f = cb->ky.c_f;
    sp->cat_bp = cat.bp;
  }
  memcpy(&sp->ff, &cb->ff, sizeof(FLAG));
  sp->c_f = c_f;
  cat.n_s++;
}

int load_stack(int f)/*cb*/
{
  STACK *sp;
  int c_f;

  if (!cat.n_s) {
    clear_flag();
    delnl(gl.pathname, cat.work[W_DIR]);
    return C_DIR;
  }
  cat.n_s--;
  sp = cat.stack[cat.n_s];
  strcpy(cb->tag, sp->tag);
  if (f) {
    delnl(gl.pathname, sp->pathname);
    strcpy(cat.work[W_DIR], sp->w_dir);
    strcpy(cat.work[W_OLD], sp->w_old);
    chdir(cat.work[W_DIR]);
  }
  free(sp->pathname);
  free(sp->tag);
  free(sp->w_dir);
  free(sp->w_old);
  if (sp->ky_str) {
    strcpy(cb->ky.str, sp->ky_str);
    cb->ky.c_f = sp->ky_c_f;
    cat.bp = sp->cat_bp;
    free(sp->ky_str);
  }
  memcpy(&cb->ff, &sp->ff, sizeof(FLAG));
  c_f = sp->c_f;
  free(sp);
  cat.stack[cat.n_s] = NULL;
  return c_f;
}

void res_vgamode(void)/*cb*/
{
  if (cat.ws) {
    gl.ws = 0;
    cat.ws = 0;
    sw_ws(0);
    layer_disp(0);
    layer_mode(0);
    cb->ky.k_n = K_WS;
    kill(cb->c_pid, SIGTSTP);
  }
}


void susp_stdin(int f)/*cb*/
{
  if (!gl.curr && cb->s_pid > 0) {
    CONT *cont = get_cont(cat.cont, cb->s_pid);
    cont->pp = cat.pp;
    cont->fd = cb->in.fd;
    cont->row = cat.row;
    kill(-cb->s_pid, SIGTSTP);
    cb->s_pid = 0;
    if (f) cb->c_f = C_PIPE; /* ̰κݤ cb->c_f (go_cons) */
  }
}

void delnl(char *pathname, char str[])/*cb*/
{
  int i;

  strcpy(pathname, str);
  if ((i = tabchrstr(pathname, '\n', NULL))) pathname[i-1] = 0;
}
