#include "cb.h"
#include "cat.h"
CHILD *init_cat(CHILD *chp, int *c_fp)/*cb*/
{ /* 
    base ¤ν
    cat.base[0] : ̥ե/֥饦ܼ
    cat.base[1] : ֥饦
    cat.base[2] : DU 
    cat.base[3] : MENU
    cat.base[4] : tar,lha ٥Ÿ
    cat.base[5] : GREP ʸ
    cat.base[6] : GREP 
    cat.base[7] : ȥǥ쥯ȥ
    cat.base[8] : tar,lha ܼ
    cat.base[9] : tar,lha 
    cat.base[10]: HELP ֥饦ܼ
    cat.base[11]: HELP ֥饦/TTY ܼ
    cat.base[12]: stdin  
    cat.base[13]: DIR,FILE
    cat.base[14]: LOG
    cat.base[15]: PAL
    cat.bi      : ɸ
  */
  int i;
  struct stat st;
  static int c_f, n_base; /* static: for setjmp */

  n_base = 0;
  c_f = *c_fp;
  gl.code_1 = gl.code_2 = n_base = 0;
  switch(c_f) {
  case C_GREP:
    n_base = 5+cb->ff.shift;
    free_base(&cat.base[n_base]);
    malloc_cgrep(&cat.base[n_base]);
    break;
  case T_GREP:
    if (cb->c_f != T_SKIP) {
      free_base(&cat.base[6+cb->ff.shift]);
      malloc_tgrep(&cat.base[6+cb->ff.shift]);
    }
  case TT_GREP:
    c_f = T_GREP;
    n_base = 6+cb->ff.shift;
    break;
  case C_BROW:  
    n_base = 0+cb->ff.shift;
    break;
  case T_TAR:
  case T_LHA:
  case T_UNZIP:
    n_base = 8+cb->ff.shift;
    c_f = (c_f == T_TAR) ? C_TAR : ((c_f == T_LHA) ? C_LHA : C_UNZIP);
    break;
  case C_CUT:  
    if (cb->ff.arc) n_base = 9+cb->ff.shift;
    else if (!cb->ff.shift && cb->ff.lb == E_MENU) n_base = 11;
    else n_base = 1+cb->ff.shift;
    break;
  case T_DU:
    n_base = 2;
    break;
  case C_MENU:
  case C_CRT:
  case C_LIST:
    n_base = 3;
    free_base(&cat.base[3]);
    if (c_f == C_MENU) malloc_list(&cat.base[3], cat.menu);
    else if (c_f == C_CRT) malloc_list(&cat.base[3], cat.crt);
    else if (c_f == C_LIST) malloc_list(&cat.base[3], cat.list);
    break;
  case C_TTY:
  case C_PAL:
  case C_WID:
  case C_SYS:
  case C_SYS0:
  case C_SYS1:
    n_base = 11;
    free_base(&cat.base[11]);
    switch(c_f) {
    case C_TTY:
      malloc_list(&cat.base[11], cat.tty);
      mask_tty(cat.base[11].pp->next->next);
      break;
    case C_PAL:
      malloc_list(&cat.base[11], cat.pal);
      break;
    case C_WID:
      malloc_list(&cat.base[11], cat.wid);
      break;
    case C_SYS:
      malloc_list(&cat.base[11], cat.sys);
      break;
    case C_SYS0:
      malloc_list(&cat.base[11], cat.sys0);
      break;
    case C_SYS1:
      malloc_list(&cat.base[11], cat.sys1);
      break;
    }
    break;
  case C_HELP:
    if (cb->c_f != C_SKIP) {
      free_base(&cat.base[10]);
      cat.help = make_help(cat.help);
      malloc_help(&cat.base[10]);
    }
    n_base = 10;
    break;
  case T_HELP:
    if (cb->c_f != C_SKIP) {
      free_base(&cat.base[10]);
      cat.help = make_help(cat.help);
      init_text(&cat.base[10], strlen(cat.help), (int)cat.help,
		&cat.base[10].text, NULL);
    }
    n_base = 10;
    break;
  case C_LOG:
    free_base(&cat.base[14]);
    stat(gl.err, &st);
    init_text(&cat.base[14], st.st_size - cat.err, cat.err, 
	      &cat.base[14].text, gl.err);
    n_base = 14;
    break;
  case C_LFILE:
  case C_LDIR:
    n_base = 13;
    free_base(&cat.base[n_base]);
    if (c_f == C_LFILE) malloc_list(&cat.base[n_base], cat.file);
    else malloc_list(&cat.base[n_base], cat.dir);
    cb->ff.bs = 1;
    break;
  default:
    if (cb->c_f == C_SKIP) {
      switch(c_f) {
      case C_DIR:
	n_base = 7;
	break;
      case C_TAR:
      case C_LHA:
      case C_UNZIP:
	n_base = 8+cb->ff.shift;
	break;
      case C_FILE:
      case C_BIN: /* ¾ü(stdin)ʳΥθư */
	n_base = 0+cb->ff.shift;
	stat(gl.pathname, &st);
	break;
      case C_PIPE:
      case T_PIPE:
	cb->ff.bs = 0;
	set_bp(cat.bi);
	*c_fp = C_PIPE;
	return chp;
	break;
      case C_DU:
	n_base = 2;
	break;
      }
    } else {
      if (cb->ff.bs) cb->ff.bs = 0;
      gl.code_1 = gl.code_2 = 0;
      if (c_f == T_PIPE) {
	cat.bi = calloc(sizeof(BASE), 1);
	init_base(cat.bi);
	cat.pp = malloc_pipe(cat.bi, NULL);
	if (!gl.curr && cb->s_pid > 0) 
	  cat.cont = add_cont(cat.cont, cb->s_pid);
	cat.pipe = save_list(cat.pipe, cat.work[W_PIPE], cb->pn, NULL);
	cb->ff.bs = 0;
	set_bp(cat.bi);
	*c_fp = C_PIPE;
	return chp;
      }
      free_base(&cat.base[0+cb->ff.shift]);
      free_base(&cat.base[1+cb->ff.shift]);
      free_base(&cat.base[3+cb->ff.shift]);
      free_base(&cat.base[4+cb->ff.shift]);
      free_base(&cat.base[5+cb->ff.shift]);
      free_base(&cat.base[8+cb->ff.shift]);
      free_base(&cat.base[9+cb->ff.shift]);
      free_base(&cat.base[11+cb->ff.shift]);
      free_base(&cat.base[12+cb->ff.shift]);
      switch(c_f) {
      case C_DU:
	n_base = 2+cb->ff.shift;
	free_base(&cat.base[n_base]);
	if (stat(gl.pathname, &st) < 0)
	  clear_base(&cat.base[n_base]); /* RunRun  DU */
	else 
	  malloc_file(c_f, &cat.base[n_base], get_child(NULL, "du", NULL));
	break;
      case C_DIR:
	n_base = 7;
	free_base(&cat.base[n_base]);
	if (stat(gl.pathname, &st) < 0)
	  save_log("cb: %s: No such directory\n", gl.pathname);
	if (!S_ISDIR(st.st_mode)) /* ǲǥ쥯ȥ̾ */
	  get_dir(gl.pathname);
	chdir(gl.pathname);
	if (st.st_size < 0 && c_f == C_DIR) 
	  clear_base(&cat.base[n_base]);
	else malloc_file(c_f, &cat.base[n_base], 
			 get_child(NULL, "ls", gl.pathname));
	break;
      case C_UNZIP:
      case C_LHA:
      case C_FILE:
      case C_TAR:
	n_base = 0+cb->ff.shift;
	/* ե륵 */
	if ((i = stat(gl.pathname, &st)) < 0 || st.st_size <= 0) {
	  if (i < 0) 
	    sprintf(gl.log, "cb: %s: %s\n", gl.pathname, strerror(errno));
	  else sprintf(gl.log, "cb: %s: No size\n", gl.pathname);
	  save_log("%s", gl.log);
	  clear_base(&cat.base[n_base]);
	} else {
	  do {
	    i = is_child(&chp, gl.pathname, 1, NULL, 0);
	    if (cb->f.man) cb->f.man = 0;
	    switch(i) {
	    case C_BROW:
	      c_f = C_BROW;
	      i = C_BROW;
	      cb->ff.bs = 1;
	      break;
	    case C_EXEC:
	      cb->vf.jmp = 0;
	      *c_fp = i;
	      return chp;
	    case C_FILE:
	      init_text(&cat.base[n_base], st.st_size, 0, 
			&cat.base[n_base].text, gl.pathname);
	      continue;
	    case C_TAR:
	    case C_LHA:
	    case C_UNZIP:
	      n_base = 8+cb->ff.shift;
	      c_f = i;
	      free_base(&cat.base[4+cb->ff.shift]);
	      malloc_head(c_f, &cat.base[n_base], chp);
	      if (c_f == C_TAR && cat.base[n_base].size) {
		if (!tabchrstr(chp->ext, 'z', NULL) &&
		    !tabchrstr(chp->ext, 'Z', NULL))
		  init_text(&cat.base[4+cb->ff.shift], st.st_size, 0, 
			    &cat.base[4+cb->ff.shift].text, gl.pathname);
		if (cat.base[4+cb->ff.shift].size)
		  malloc_tar(&cat.base[4+cb->ff.shift]);
	      } else if (c_f == C_LHA && cat.base[n_base].size) {
		free_base(&cat.base[4+cb->ff.shift]);
		malloc_lha(&cat.base[4+cb->ff.shift], chp);
	      } else if (c_f == C_UNZIP && cat.base[n_base].size) {
		free_base(&cat.base[4+cb->ff.shift]);
		malloc_unzip(&cat.base[4+cb->ff.shift], chp);
	      }
	      if (!cat.base[4+cb->ff.shift].size)/*C_LHA or C_UNZIP Ǥ */
		clear_base(&cat.base[n_base]);
	      continue;
	      break;
	    case C_BIN:
	      if (!strncmp(chp->argv[2], "-man", 4)) {
		if (init_text(&cat.base[n_base], st.st_size, 0, NULL, 
			      gl.pathname) == J_EUC) 
		  chp = get_child(NULL, "groff", gl.pathname);
	      }
	      c_f = i;
	      break;
	    }
	    malloc_file(i, &cat.base[n_base], chp);
	  } while (0); 	
	}
	break;
      }
    }
  }
  set_bp(&cat.base[n_base]);
  *c_fp = c_f;
  return chp;
}
    
void init_pos(int c_f)/*cb*/
{ /* СĹ٥Ȳս */
  int i, j, k, mes;
  char *cp;

  for (i = k = 0; i < N_SEL; i++) cb->sel[i].c = 0;
  for (j = E_SCROLL; cat.mode[j].p; j++)
    init_sel(cat.mode[j].x, 32-6, 
	     cat.mode[j].x+strlen(cat.mode[j].p)*8, 32+10, j);
  if (cb->vf.key) init_sel(cb->ws.x-26, 5, cb->ws.x-10, 21, E_CR);
  init_sel(6, 5, 24, 23, E_QUIT);
  gl.len = (cb->vf.key) ? strlen(gl.pathname) : cb->ws.col/2-2;
  cb->max = N_MODE;
  strcpy(cat.work[W_PATH], gl.pathname);
  if (!cb->vf.key && *cat.work[W_PATH] != ' ') {
    strcpy(cat.work[W_PATH], gl.pathname);
    if ((i = strlen(cat.work[W_PATH])) > gl.len) {
      j = 1;
      cp = &cat.work[W_PATH][i-(gl.len-4)];
      if (cp[-1] == '/') j = 0;
      cp[-1] = 0;
      for (k = 0; cat.work[W_PATH][k]; k++) 
	if (cat.work[W_PATH][k] == '/' && !gl.curr) {
	  init_sel(6+LBX, 0+32-15-11, 14+LBX, 14+32-15-9, cb->max);
	  cb->max++;
	}
      strcpy(cat.work[W_PATH], "/...");
      strcat(cat.work[W_PATH], cp);
      cb->max -= j;
    }
    i = 0;
    cp = &cat.work[W_PATH][tabchrstr(cat.work[W_PATH], '/', NULL)];
    if (!gl.curr)
      do {
	k = 8 * (cp - cat.work[W_PATH] + i) - 2 + LBX;
	init_sel(k, 0+32-15-11, k + 8, 14+32-15-9, cb->max);
	cp = &cp[i];
	cb->max++;
      } while (*cp && (i = tabchrstr(cp, '/', NULL)) != 0);
  }
  if (*cb->tag && !cb->vf.key) 
    init_sel(8*gl.len+8+16+24, 5, cb->ws.x-6, 23, E_LABEL);
  else init_sel(0, 0, 0, 0, E_LABEL);
  cb->num = cb->max;
  switch(c_f) {
  case C_DIR:
  case C_LFILE:
  case C_LDIR:
  case C_CRT:
  case C_LIST:
  case C_MENU:
  case C_TTY:
  case C_PAL:
  case C_WID:
  case C_SYS:
  case C_SYS0:
  case C_SYS1:
  case C_BROW:
  case C_HELP:
  case C_DU:  
  case T_DU:  
  case C_TAR:
  case C_LHA:
  case C_UNZIP:
  case C_GREP:
  case T_GREP:
    mes = (cb->pn.nline > cb->ws.row-1) ? cb->ws.row-1 : cb->pn.nline-1;
    for (i = 0; i < mes; i++, cb->max++) 
      switch(c_f) {
      case C_DIR:
#if 1
	init_sel(266, 48+i*cb->rline, 435, 48+i*cb->rline+cb->rline-1,cb->max);
#else
	init_sel(266, 48+i*cb->rline, 266+cb->ws.col*8/4, 48+i*cb->rline+cb->rline-1,cb->max);
#endif
	break;
      case C_MENU:
      case C_CRT:
      case C_TTY:
      case C_PAL:
      case C_WID:
      case C_SYS:
      case C_SYS0:
      case C_SYS1:
      case C_HELP:
      case C_LIST:
#if 1
	init_sel(1, 48+i*cb->rline, 183, 48+i*cb->rline+cb->rline-1, cb->max);
#else
	init_sel(1, 48+i*cb->rline, 1+cb->ws.col*8/4, 48+i*cb->rline+cb->rline-1, cb->max);
#endif
	break;
      case C_LFILE:
      case C_LDIR:
      case C_BROW:
      case C_GREP:
      case T_GREP:
#if 1
	init_sel(1, 48+i*cb->rline, 311, 48+i*cb->rline+cb->rline-1, cb->max);
#else
	init_sel(1, 48+i*cb->rline, 1+cb->ws.col*8/2, 48+i*cb->rline+cb->rline-1, cb->max);
#endif
	break;
      case C_DU:
      case T_DU:
#if 1
	init_sel(65, 48+i*cb->rline, 223, 48+i*cb->rline+cb->rline-1, cb->max);
#else
	init_sel(65, 48+i*cb->rline, 65+cb->ws.col*8/3, 48+i*cb->rline+cb->rline-1, cb->max);
#endif
	break;
      case C_TAR:
      case C_LHA:
      case C_UNZIP:
#if 1
	init_sel(154, 48+i*cb->rline, 327, 48+i*cb->rline+cb->rline-1,cb->max);
#else
	init_sel(154, 48+i*cb->rline, 154+cb->ws.col*8/3, 48+i*cb->rline+cb->rline-1,cb->max);
#endif
	break;
      }
  }  
  if (cb->pn.nline <= cb->ws.rrow) cat.dx = cb->bar-1;
  else
    if (!(cat.dx = cb->bar * (cb->ws.rrow) / cb->pn.nline)) cat.dx++;
}


int init_text(BASE *base, int size, int tell, char **pointer, char *pathname)/*cb*/
{ /* ٥եɽκݤΥݡɤ߹ߡԥ */
  FILE *file = NULL;
  char *text;
  int i, c_f, kanji = J_ANK;

  if (!size || 
      !(text = malloc(size+2)) ||  /* +2:Ǥʤ */
      						/* ( init_type())*/
      (pathname && !(file = fopen(pathname, "rb")))) {
    clear_base(base);
    return J_ANK;
  }
  if (tell && !cb->ff.arc) {
    c_f = C_CUT;
    if (tell < 0) tell = 0;
  } else c_f = C_FILE;
  if (pathname) {
    if (tell) fseek(file, tell, 0);
    cb->d_pid = 1;
    if (size < T_SIZE) i = fread(text, 1, size, file);
    else i = read_text(text, file);
    fclose(file);
  } else {
    cb->d_pid = 1;
    memcpy(text, (char*)tell, size);
    i = size;
  }
  size = i;
  i = cb->d_pid;
  cb->d_pid = 0;
  if (i == -1)
    if (pointer && pathname) 
      size = (base == &cat.base[4+cb->ff.shift]) ? 0 : T_SIZE/64;
  if (!size) {
    clear_base(base);
    return J_ANK;
  }
  if (pointer) {
    base->size = size;
    *pointer = text;
    if (base == &cat.base[4+cb->ff.shift]) return J_ANK;
    kanji = malloc_file(c_f, base, NULL);
  } else {
    init_type(&text, size, &kanji, 0);
    free(text);
  }
  return kanji;
}

int init_type(char **text_p, int size, int *kanjip, int c_f)/*cb*/
{
  char *cp, *text = *text_p;
  int kanji, oldsize;

  if (!size) return 0;
  if (kanjip) {
    if (c_f == C_FILE)
      if (text[size-1] != '\n') { /*  nl Ǥʤ */
	for (cp = &text[size-2]; *cp != '\n' && cp >= text; cp--) ;
	if (cp > text && cp[-1] == '\r') { /*  '\r', '\n' λ */
	  text[size++] = '\r';
	  text[size++] = '\n';
	} else text[size++] = '\n';
      }
    oldsize = size;
    do {
      if ((kanji = init_kanji(&size, &text, c_f)) == J_JIS) 
	size = jistoeuc(text, size);
      else if (kanji == J_SJIS) size = sjistoeuc(&text, size, oldsize);
      else continue;
      kanji = J_EUC;
    } while (0);
    *kanjip = kanji;
  }
  *text_p = text;
  return size;
}

int jistoeuc(unchar *text, int size)/*cb*/
{ /* ɤ JIS  EUC Ѵ */
  int i, j, k_f;
  unchar *temp;

  temp = malloc(size*2); 
  for (i = j = k_f = 0; size; size--) {
    if (text[j] == EC) {
      j++;
      k_f++;
      size--;
    }
    switch(k_f) {
    case 0:
      if (text[j] == 0x0e) {
	k_f = 6;
	j++;
	continue;
      }
      temp[i] = text[j] & 0x7f;
      i++;
      j++;
      break;
    case 1:
      if (text[j] == '$') k_f = 2;
      else if (text[j] == '(') k_f = 5;
      j++;
      break;
    case 2:
      if (text[j] == 'B' || text[j] == '@') k_f = 3;
      j++;
     break;
    case 3:
      temp[i] = text[j] | 0x80;
      i++;
      j++;
      break;
    case 4:
      if (text[j] == '(') k_f = 5;
      j++;
      break;
    case 5:
      if (text[j] == 'B' || text[j] == 'J') k_f = 0;
      j++;
      break;
    case 6:
      if (text[j] == 0x0f) {
	j++;
	k_f = 0;
	continue;
      }
      temp[i] = 0x8e;
      i++;
      temp[i] = text[j] | 0x80;
      i++;
      j++;
      break;
    }  
  }
  memcpy(text, temp, i);
  free(temp);
  return i;
}

int sjistoeuc(char **text_p, int eucsize, int sjissize)/*cb*/
{ /* ɤ SJIS  EUC Ѵ */
  int i;
  uint p, q;
  unchar *new, *old = (unchar*)*text_p;

  new = malloc(eucsize);
  for (i = eucsize = 0; i < sjissize; ) {
    p = old[i];
    if (p == '\r') {
      i++;
      continue;
    }
    if (is_sjis_1_byte(p)) {
      q = old[i+1];
      p = (p << 1) -((p > 0x9f) ? 0x161 : 0xe1);
      if (q < 0x9f) q = q - ((q > 0x7f) ? 0x20 : 0x1f);
      else {
	q = q - 0x7e;
	p++;
      }
      new[eucsize] = p | 0x80;
      new[eucsize+1] = q | 0x80;
      eucsize += 2;
      i += 2;
    } else if (is_sjiskana(p)) {
      new[eucsize] = 0x8e;
      new[eucsize+1] = p;
      eucsize += 2;
      i++;
    } else {
      new[eucsize] = p;  
      i++;
      eucsize++;
    }
  }
  free(old);
  *text_p = new;
  return eucsize;
}

PP *set_pp(int x)/*cb*/
{
  int i;
  PP *pp;

  if (x > BX + cb->bar - cat.dx) 
    x = BX + cb->bar - cat.dx;
  cb->pn.pos = 0;
  pp = gl.bp->pp[1].next;
  for (i = cb->pn.nline*(x-BX)/cb->bar; i; i--) {
    if ((cb->pn.pos+=cb->rline) >= (cb->pn.nline-(cb->ws.row-2))*cb->rline-1) {
      cb->pn.pos = (cb->pn.nline - (cb->ws.row-2)) * cb->rline;
      break;
    }
    pp = pp->next;
  }  
  return pp;
}

PP *set_forw_pp(int event)/*cb*/
{ /* Сΰ(x)եΰ()˴ */
  int i;
  PP *pp = NULL;

  if (event == E_NEXT) {
    for (i = 0, pp = gl.bp->pp[1].next; i < cb->pn.pos; i += cb->rline) 
      pp = pp->next;
    for (i=cb->ws.row-2, cb->y = MY+2+i*cb->rline; i; i--, cb->y-=cb->rline) {
      if (cb->c_f == C_PIPE && cb->s_pid && cb->in.fd
	  && cb->pn.pos >= cb->rpos - cb->rline*2)
	cat.pp = malloc_pipe(cat.bi, cat.pp);
      else if (cb->pn.pos >= (cb->pn.nline - (cb->ws.row-2)) * cb->rline) {
	cb->pn.pos = (cb->pn.nline - (cb->ws.row-2)) * cb->rline;
	pp = gl.bp->pp[1].next;
	for (i = 0; i < cb->pn.pos; i += cb->rline) pp = pp->next;
	cb->idle = 0;
	break;
      }
      pp = pp->next;
      cb->pn.pos += cb->rline;
    }
  } else {
    if (cb->c_f == C_PIPE && cb->s_pid && cb->in.fd) {
      cb->y = cb->ws.y - cb->rline;
      cb->vf.in = 1;
      draw_idle();
      do {
	cat.pp = malloc_pipe(cat.bi, cat.pp);
      } while (cb->in.fd && cb->vf.in);
      cb->vf.in = 0;
      draw_idle();
    }
    cb->pn.pos = (cb->pn.nline - (cb->ws.row-2)) * cb->rline;
    pp = gl.bp->pp[1].next;
    for (i = 0; i < cb->pn.pos; i += cb->rline) pp = pp->next;
  }
  return pp;
}

PP *set_back_pp(int event)/*cb*/
{
  int i;
  PP *pp;

  if (event == E_PREV) {
    cb->y = MY+2;
    if (cb->pn.pos <= 0) {
      pp = gl.bp->pp[1].next;
      cb->idle = 0;
      cb->pn.pos = 0;
    } else {
      for (i = 0, pp = gl.bp->pp[1].next; i < cb->pn.pos; i += cb->rline)
	pp = pp->next;
      for (i = cb->ws.row-2, cb->y = MY+2-16; i; i--, cb->y += cb->rline) {
	if (cb->pn.pos <= 0) {
	  pp = gl.bp->pp[1].next;
	  cb->pn.pos = 0;
	  cb->idle = 0;
	  break;
	}
	pp = pp->prev;
	cb->pn.pos -= cb->rline;
      }
    }
  } else {
    pp = gl.bp->pp[1].next;
    cb->pn.pos = 0;
  }
  return pp;
}

void init_frame(void)/*cb*/
{ /* СΥ٥Ȳս */
  init_sel(5, 32-5, 19, 32+9, 2);
  init_sel(cb->bar+36, 32-5, cb->bar+50, 32+9, 3);
  init_sel(28, 32-3, cb->bar+27, 32+7, 4);
  init_sel(28, 32-3, cb->bar+27, 32+7, 5);
}

void draw_frame(void)/*cb*/
{ /* MY ꥢΥܥɽ */
  int i, xs, ys, xe, ye;
  static int n;

  if (!n) for (n = E_SCROLL; cat.mode[n].p; n++) ;
  for (i = E_HEAD; i < cb->num; i++) {
    if (cb->vf.key && i == E_CR) ;
    else if (i == E_RIGHT || (i > n-1 && i < N_MODE && i != E_QUIT) || 
	     (!*cb->tag && i == E_LABEL)) 
      continue;
    if (i == E_LEFT) {
      xs = 26;
      ys = 32-5;
      xe = cb->bar+29;
      ye = 32+9;
    } else {  
      xs = cb->sel[i].xs;
      ys = cb->sel[i].ys;
      xe = cb->sel[i].xe;
      ye = cb->sel[i].ye;
    }  
    if ((cb->ff.grep % 2 && i == E_GREP) ||
	(cb->vf.key && ((i >= E_SCROLL && i <= E_MENU) || 
			(i >= E_HEAD && i <= E_TAIL))) ||
	(gl.curr && 
	 ((i >= E_CRT && i <= E_DU) || i == E_MENU)) ||
	 (((cb->s_pid && cb->in.fd) || cb->w_pid) && i == E_FIFO) ||
	(cb->ff.lb && i == cb->ff.lb)) {
      vramline(xs, ys, xe-1, ys, 1, V_SET, 0);
      vramline(xs, ys, xs, ye-1, 1, V_SET, 0);
      vramline(xs, ye, xe, ye, 2, V_SET, 0);
      vramline(xe, ys, xe, ye, 2, V_SET, 0);
    } else {
      vramline(xs, ys, xe-1, ys, 2, V_SET, 0);
      vramline(xs, ys, xs, ye-1, 2, V_SET, 0);
      vramline(xs, ye, xe, ye, 1, V_SET, 0);
      vramline(xe, ys, xe, ye, 1, V_SET, 0);
    }
  }
}

void draw_pos(int pos, int init)/*cb*/
{ /* Сɽ(ư) */
  static int dx, x;
  static uint *addr, *base, buff[32*LINE_LWORDS];
  int xs, xe, i;
  
  if (!cb->pn.nline) return;
  if (init) memcpy(buff, get_bf1(0, 32-3), 14*LINE_BYTES);
  cat.x = cb->bar * pos / cb->pn.nline / cb->rline;
  if (cat.x != x || init) {
    if (!init) {
      vramsetfb(gl.bf);
      memcpy(get_bf1(0, 32-3), buff, 14*LINE_BYTES);
    }  
    xs = cat.x+BX;
    if ((xe = cat.x+cat.dx+BX) > cb->bar+27) xe = cb->bar+27;
    vramline(xs, 32-3, xe-1, 32-3, 1, V_SET, 0);
    vramline(xs, 32-3, xs, 32+6, 1, V_SET, 0);
    vramline(xs, 32+7, xe, 32+7, 2, V_SET, 0);
    vramline(xe, 32-3, xe, 32+7, 2, V_SET, 0);
    if (!init) {
      base = get_fb1(0, 32-3);
      addr = get_bf1(0, 32-3);
      for (i = 0; i < 14; i++) {
	memcpy(base, addr, cb->bar+32);
	base += LINE_LWORDS;
	addr += LINE_LWORDS;
      }
      vramsetfb(gl.fb);
    }
    x = cat.x;
    dx = cat.dx;
    init_sel(-1, -1, xs-2, -1, E_LEFT);
    init_sel(xe+2, -1, -1, -1, E_RIGHT);
  }
  if (cb->push >= E_HEAD && cb->push <= E_RIGHT) cb->push = 0;
}

int read_text(char *text, FILE *file)/*cb*/
{
  int size;

  if ((size = fread(text, 1, T_SIZE, file)) == T_SIZE && cb->d_pid == 1)
    size += read_text(&text[T_SIZE], file);
  return size;
}

void mask_tty(PP *pp)/*cb*/
{
  int i;

  for (i = 1; ; i++, pp = pp->next)
    if (cb->tty == i) {
      memcpy(&pp->cs[4], " -----", 6);
      break;
    }
}

char *make_help(char *help)/*cb*/
{
  FILE *file;
  char str[100];
  struct stat st_help, st_conf;
  int len_h, len_n, tell;

  if (help) free(help);
  stat(gl.help, &st_help);
  stat(gl.config, &st_conf);
  file = fopen(gl.config, "r");
  while (fgets(str, 100, file)) if (!strncmp(str, "-KEY", 4)) break;
  len_h = st_help.st_size;
  len_n = strlen(gl.note);
  tell = ftell(file);
  help = malloc(len_h + len_n + st_conf.st_size-tell);
  memcpy(&help[len_h], gl.note, len_n);
  fread(&help[len_h + len_n], 1, st_conf.st_size-tell, file);
  fclose(file);
  file = fopen(gl.help, "r");
  fread(help, 1, st_help.st_size, file);
  fclose(file);
  help[len_h + len_n + st_conf.st_size-tell] = 0;
  return help;
}

void clear_segv(void)/*cb*/
{
  if (cb->vf.jmp) return;
  cb->vf.jmp = 3;
  strcpy(cb->pathname, gl.pathname);
  free_cat();
}
 
