#include "cb.h"
static struct {
  char str[256], argv[8][128];
  FILE *fd;
  int intr, alrm;
} sub;

void init_color(uint color, uint *convdata)/*cb*/
{ /* ɽѥ */
  int i, j;
  uint n;

  for (i = 0; i < 256; i++) {
    for (n = 0, j = 0; j < 8; j++) 
      if (i & (1<<j)) 
	n |= (color <<(4*(7-j)));
    convdata[i] = n;
  }
}

CHILD *save_child(CHILD *child, char *c_p, int g_f)/*cb*/
{ /* ưץ */
  int i, j, n_str;
  char **sp;
  static char path[1000];
  /* sub.argv[0] ==> child->ext, sub.argv[1..] ==> child->argv[1..] */

  if (!*path) strcpy(path, getenv("PATH"));
  if (!child) {
    child = (CHILD*)calloc(sizeof(CHILD), 1);
    if (g_f == 1) child->exec = 1;
    for (n_str = 0; n_str >= 0; n_str++) {
      if (g_f == 3 && !n_str) { /* -GREP */
	strcpy(sub.str, " ");	/* for suffix */
	i = 1;
      } else if (g_f >= 2 && n_str && n_str < 3) {
        if (n_str == 1) strcpy(sub.str, "egrep");
	else strcpy(sub.str, "-b");
	i = strlen(sub.str);
      } else {
        while (*c_p == ' ' || *c_p == '\t') c_p++;
        if (*c_p == '#') i = 0;
        else if (*c_p == '\x27') {
          for (i = 0, c_p++; *c_p != '\x27'; c_p++, i++)
            if ((sub.str[i] = *c_p) == 0) break;
	  c_p++;
        } else if (*c_p == '\x22') {
          for (i = 0, c_p++; *c_p != '\x22'; c_p++, i++)
            if ((sub.str[i] = *c_p) == 0) break;
	  c_p++;
	} else
          for (i = 0; *c_p != ' ' && *c_p != '\t'; c_p++, i++)
            if ((sub.str[i] = *c_p) == 0) break;
      }
      if (!i) { /* ʸ󤬤ʤ */
        j = 0;
	child->argv = (char**)malloc(sizeof(char*)*(n_str+2));
	if (strcmp("du", sub.argv[1])) {
	  if (g_f < 0) {
	    child->argv[n_str] = malloc(256);/* for ʸ */
	    strcpy(child->argv[n_str], "pattern");
	  } else if (!strcmp(sub.argv[0], ".stdin")) j++;
          else {
	    child->argv[n_str] = malloc(256); /* for path */
	    strcpy(child->argv[n_str], "path");
	  }  
	}
	child->argv[n_str+1-j] = NULL;
	child->argc = n_str-j; /* child->argv[child->argc] = path */
	for (j = 0; j < n_str; j++) {
	  if (j) sp = &child->argv[j];
	  else sp = &child->ext;
	  *sp = strdup(sub.argv[j]);
	}
	if (set_path(child->argv, path) < 0)
	  save_log("cb: %s: %s isn't installed\n", 
		   gl.config, child->argv[1]);
	n_str = -2;
      }	else {
	sub.str[i] = 0;
        strcpy(sub.argv[n_str], sub.str);
      }
    }  
  } else child->next = save_child(child->next, c_p, g_f);
  return child;
}

void rexec_cb(int a)/*cb*/
{ /* ۾߸κƵư */
  int shmid;
  char k_str[24], c_str[24];
  static CB cb_a[1];

  if ((shmid = shmget(IPC_CB, SHMCB_SIZE, 0666)) >= 0) {
    cb = (CB*)shmat(shmid, 0, 0);
    if (check_active() && cb->k_pid) {
      pid_str(k_str, cb->k_pid);
      pid_str(c_str, cb->c_pid);
      if (check_proc(k_str) >= 0) {
	cb->vf.jmp = 1;
	strcpy(cb->pathname, (a == 1) ? "-a" : "-A");
	kill(cb->k_pid, SIGTERM);/*cb -a(A)  (stdin)ץ exit ʤ*/
	while (check_proc(c_str) >= 0) usleep(10000);
	while (check_proc(k_str) >= 0) usleep(10000);
      }
    }
    memcpy(cb, cb_a, sizeof(CB)); /* ͭꥯꥢ */
    shmdt((char*)cb);
  }  
}

int set_path(char **argv, char *path)/*cb*/
{ /* argv[0] ˥եѥ */
  int i, j;
  struct stat st;
  
  argv[0] = NULL;
  j = -1;
  while ((i = tabchrstr(path, ':', NULL)) != 0) {
    path[i-1] = 0;
    strcpy(sub.str, path);
    path[i-1] = ':';
    strcat(sub.str, "/");
    strcat(sub.str, argv[1]);
    if ((j = stat(sub.str, &st)) >= 0) {
      argv[0] = strdup(sub.str);
      strcpy(argv[0], sub.str);
      break;
    }	
    path = &path[i];
  }  
  return j;
}

void free_child(CHILD *child, CHILD *new)/*cb*/
{ /* child ¤γ */
  CHILD *chp, *chb;

  if (!child) return;
  for (chb = chp = child; chp; chp = chb) {
    chb = chp->next;
    if (new && chp == new) break;
    for (chp->argc = 0; chp->argv[chp->argc]; chp->argc++) 
      free(chp->argv[chp->argc]);
    if (chp->ext) free(chp->ext);
    free(chp->argv);
    free(chp);
  }  
}

int  check_cb(void)/*cb*/
{ /* cb ư椫ɤå */
  int i, shmid, old;
  struct stat st;
  char c_str[24];

  if (stat(gl.config, &st) < 0) {
    perror(gl.config);
    return X_STAT;
  }
  if (sizeof(CB) > SHMCB_SIZE) {
    /* 
	sizeof(CB) ѤƱ IPC_CB  shmget ǤʤʤкȤ
	SHMCB_SIZE Ƥ뤿 sizeof(CB) Υåɬ
    */
    fprintf(stderr, "cb: Sizeof(CB) is %x. Check 'SHMCB_SIZE'\n", sizeof(CB));
    exit(1);
    /*
	sizeof(CB) > SHMCB_SIZE ä cb.h  SHMCB_SIZE ͤĴ
    */
  }  
  for (i = 0x70a; i < IPC_CB; i++)
    if ((shmid = shmget(i, SHMCB_SIZE, 0666)) >= 0) {
      cb = (CB*)shmat(shmid, 0, 0);
      old = (cb->magic & 0xfff) == i;
      shmdt((char*)cb);
      if (old) return X_OLD;
    }
  if ((shmid = shmget(IPC_CB, SHMCB_SIZE, 0666)) >= 0) {
    cb = (CB*)shmat(shmid, 0, 0);
    if (check_active()) {
      pid_str(c_str, cb->c_pid);
      if (check_proc(c_str) < 0) i = X_ERR;
      else i = (cb->vf.wait || cb->delay) ? X_BUSY : X_ACTIVE;
    } else if (check_magic(M_TTY)) i = X_EXEC;
    else i = X_INIT;
    if (i != X_ACTIVE && i != X_BUSY) {
      shmdt((char*)cb);
      cb = NULL;
    }
  } else i = X_INIT;
  return i;
}

void get_time(char *str, int l)/*cb*/
{ /*  */
  struct tm tt;
  time_t ll;
  char tmp[256];

  time(&ll);
  memcpy(&tt, localtime(&ll), sizeof(struct tm));
  strcpy(tmp, asctime(&tt));
  if (!l) {
    tmp[20] = '\0';
    strcpy(str, &tmp[11]);
  } else {
    tmp[tabchrstr(tmp, '\n', NULL)-1] = 0;
    strcpy(str, tmp);
  }
}

void ptcpy(char *dst, char *src)/*cb*/
{ /* sizeof(pp->str) src_p  dst_p ˥ԡ(ԡ0) */
  int i;

  for (i = 0; (*dst = *src++) != '\n' && *dst != ' ' && i < 127; i++, dst++) ;
  *dst = 0;
}

void blank_screen(void)/*cb*/
{ /* кư */
  time((time_t*)&cb->ll);
  if (cb->f.blanked) return;
  cb->f.blanked = 1;
  layer_disp(0);
}

void unblank_screen(void)/*cb*/
{ /* в */
  time((time_t*)&cb->ll);
  if (!cb->f.blanked) return;
  cb->f.blanked = 0;
  layer_disp(2);
}

int   tabchrstr(void *tab, int key, char *str)/*cb*/
{
  int   i, j, k, len_s, len_t, *tabi;
  char  tp[256], sp[256], *tabc;

  if (!tab) return 0;
  if (str && str != TABI) {
    tabc = tab;
    if (key) {
      memcpy(tp, str, key);
      tp[key] = 0;
    } else strcpy(tp, str);
    if ((len_s = strlen(tp)) > (len_t = strlen(tabc))) return 0;
    if (len_s == len_t) return !strcmp(tp, tabc);
    for (k = 1, j = 0; j < len_t - len_s + 1; j++) {
      for (i = 0, k = j; i < len_s; i++, k++) sp[i] = tabc[k];
      sp[i] = '\0';
      if ((k = strcmp(tp, sp)) == 0) break;
    }
    if (!k) return j+1;
    else return 0;
  } else if (key) {
    i = 1;
    if (str == TABI) {
      tabi = tab;
      do {
	if ((j = tabi[i++ - 1]) == key && j) return --i;
      } while (j);
    } else {
      tabc = tab;
      do {
	if ((j = tabc[i++ - 1]) == key && j) return --i;
      } while (j);
    }
    return j;
  } else return 0;
}

void get_dir(char *pathname)/*cb*/
{
  int i;

  while ((i = tabchrstr(pathname, '/', NULL))) pathname = &pathname[i];
  *pathname = 0;
}

void get_filename(int c_f, char pathname[])/*cb*/
{ /* pathname ե̾ޤϥǥ쥯ȥ̾Τ߼Ф */
  char *cp, *dp;
  int i;

  /* (⡼)'\xa0'ץå */
  cp = (i = tabchrstr(pathname, '\xa0', NULL)) ? &pathname[i] : pathname;
  /* du -ab κǽ("/" ޤޤʤ ".")н */
  cp = ((i = tabchrstr(cp, '.', NULL)) && !cp[i]) ? &cp[i-1] : cp;
  for (dp = cp; (i = tabchrstr(cp, '/', NULL)); ) {
    dp = cp;
    cp = &cp[i];
  }
  if (c_f == C_DIR || c_f == C_DU) {
    *cp = '\0';
    cp = dp;
  }
  strcpy(pathname, cp);
}

char *itoa(int i)/*cb*/
{
  char tmp[32];
  static char str[32];
  int j;
  
  j = 0;
  do {
    tmp[j++] = i % 10 + '0';
    i /= 10;
  } while (i);
  tmp[j] = '\0';
  for (i = 0, j = strlen(tmp); j; i++, j--) str[i] = tmp[j-1];
  str[i] = '\0';
  return (char*)str;
}

void read_fifo(void)/*cb*/
{
  int i, shmid;

  if ((shmid = shmget(IPC_CB, SHMCB_SIZE, 0666)) >= 0) {
    cb = (CB*)shmat(shmid, 0, 0);
    if (!check_active()) {
      shmdt((char*)cb);
      goto jump;
    }
    sub.alrm = (int)signal(SIGALRM,(__sighandler_t)term_read);
    sub.intr = (int)signal(SIGINT,(__sighandler_t)intr_read);
    cb->r_pid = getpid();
    while (1) {
      sub.fd = fopen(gl.fifo[1], "r");
      while ((i = fgetc(sub.fd)) != EOF) fputc(i, stdout);
      fclose(sub.fd);
      sub.fd = NULL;
    }
  }  
jump:
  fprintf(stderr, "cb: Not ready\n");
  exit(1);
}

void intr_read(void)/*cb*/
{
  kill(cb->r_pid, SIGALRM);
}

void term_read(void)/*cb*/
{
  int i;

  if (sub.fd) {
    while ((i = fgetc(sub.fd)) != EOF) fputc(i, stdout);
    fclose(sub.fd);
  }  
  fprintf(stderr, "cb -c: Terminated\n");
  signal(SIGALRM,(__sighandler_t)sub.alrm);
  signal(SIGINT, (__sighandler_t)sub.intr);
  cb->r_pid = 0;
  shmdt((char*)cb);
  exit(0);
}

void timingloop(int delay)/*cb*/
{ /* delay λ delayޥõ̲, Ǥʤñ롼 */
  if (delay > 0) usleep(delay);
  else if (delay < 0) while (delay++) ;
}

void setpathname(char *filename, char *pathname)/*cb*/
{ /* pathname ˥եѥ */
  char tmp[256];

  if (filename) strcpy(tmp, filename);
  getcwd(pathname, 255);
  if (strcmp(pathname, "/")) strcat(pathname, "/");
  if (filename) strcat(pathname, tmp);
}

char *make_info(char str[])/*cb*/
{
  static char tmp[1000];
  int i, j;
  
  for (i = j = 0; str[i]; i++, j += 3) {
    tmp[j] = '_';
    tmp[j+1] = BS;
    tmp[j+2] = str[i];
  }
  tmp[j] = 0;
  return tmp;
}

void free_list(LIST *list)/*cb*/
{ /* malloc ǡ free */
  LIST *p;

  if (list) {
    free_list(list->left);
    p = list->right;
    free(list);
    free_list(p);
  }  
}

void free_base(BASE *base)/*cb*/
{ /* ԥݥ󥿡ƥΰ賫 */
  PP *pp;
 
  if (base->text) {
    free(base->text);
    base->text = NULL;
  }  
  if (base->pp[1].next && base->pp[1].next != &base->pp[2]) {
    for (pp = &base->pp[0]; pp->next && pp->next!=&base->pp[2]; pp = pp->next);
    for (pp = pp->prev; pp != &base->pp[0]; pp = pp->prev) {
      if (pp->next->str) free(pp->next->str);
      free(pp->next);
    }
  }  
  base->size = 0;
  base->pp[1].next = NULL;
}

int load_list(LIST *list, char *name, PN *pn, char *color)/*cb*/
{ /* list  name ʸĹܤ PN Ƥ򥳥ԡ */
  if (list) {
    if (load_list(list->left, name, pn, color)) return 1;
    if (!strcmp(&list->name[1], name)) { 
      if (pn) {
	memcpy(pn, &list->l.pn, sizeof(PN));
	pn->pos *= cb->rline;
      } else memcpy(color, list->l.color, sizeof(char)*3*N_PAL);
      return 1;
    }  
    if (load_list(list->right, name, pn, color)) return 1;
  }
  return 0;
}

LIST *save_list(LIST *list, char *name, PN pn, char *color)/*cb*/
{ /* name ʸĹܤ MARK Ƥ¸Ĥʤпΰ */
  int i;

  if (!list) {
    list = (LIST*)calloc(sizeof(LIST), 1);
    strcpy(list->name, " "); /* for check_sel() */
    strcat(list->name, name);
    if (color) memcpy(list->l.color, color, sizeof(char)*3*N_PAL);
    else {
      pn.pos /= cb->rline;
      memcpy(&list->l.pn, &pn, sizeof(PN));
    }
    list->left = list->right =NULL;
  } else if ((i = strcmp(&list->name[1], name)) > 0)
    list->left = save_list(list->left, name, pn, color);
  else if (i < 0) list->right = save_list(list->right, name, pn, color);
  else 
    if (color) memcpy(list->l.color, color, sizeof(char)*3*N_PAL);
    else {
      pn.pos /= cb->rline;
      memcpy(&list->l.pn, &pn, sizeof(PN));
    }
  return list;
}

int layer_prior(int layer)/*cb*/
{
  int ffd, req[2];
  u_short *p;

  ffd = open("/dev/fb", O_RDWR);
  req[0] = 1 * sizeof(int) + sizeof(int);
  p = (u_short*)&req[1];
  *p++ = 33;
  *p = layer;
  ioctl(ffd, FBIOCSETCRTC, req);
  close(ffd);
  return 0;
}

void print_list(LIST *list)/*cb*/
{ /* ǥХå */
  if (list) {
    print_list(list->left);
    save_log("*** list->name=%s ***\n", list->name);
    print_list(list->right);
  }
}

int cat_child(CHILD *child, char *pathname)/*cb*/
{ /* ե̾˻ҥץץ̾ղ */
  int i;

  if (!child) return 0;
  i = strlen(pathname);
  if (pathname[0] == ' ' || pathname[i-1] == '/') return 0;
  strcat(pathname, " (");
  strcat(pathname, child->argv[1]);
  strcat(pathname, ")");
  return i;
}

int is_child(CHILD **chp, char *pathname, int f, char *cut, int size)/*cb*/
{ /* path γĥҤбҥץ chp ˥ݥ */
  CHILD *child;
  int i, j, arc = cb->ff.arc;
  char *cp, *tmp;
  struct stat st;

  if (*pathname == ' ') return C_LABEL;
  if (cb->ff.cld && (!cb->f.man || !f) && 
      (i = tabchrstr(pathname, '.', NULL)) != 0) {
    for (cp = &pathname[i]; (i = tabchrstr(cp, '.', NULL)); cp = &cp[i]) ;
    if (!strcmp(cp, "man") || /* .man å */
	((isdigit(*cp) || (*cp == 'n')) && (!cp[1] || !strcmp(&cp[1], "x")))) {
      FILE *file;
      struct stat st;
      if (cut) st.st_size = 0;
      else 
	if (stat(pathname, &st) < 0) cp = NULL;
	else {
	  size = st.st_size;
	  cut = (char*)malloc(size);
	  file = fopen(pathname, "r");
	  fread(cut, 1, size, file);
	  fclose(file);
	}
      if (cut) {
	tmp = (char*)malloc(size);
	for (i = 0; i < size; i++) {
	  for (cp = tmp; cut[i] != '\n' && i < size; i++, cp++) *cp = cut[i];
	  *cp = 0;
	  if (tmp[0] == '.' && 
	      isalpha(tmp[1]) && isalpha(tmp[2])) break; /* man Ƚ */
	  cp = NULL;
	}
	free(tmp);
      }
      if (cp) {
	if (st.st_size) free(cut);
	if (f) *chp = get_child(NULL, "groff", pathname);
	return C_BIN;
      } else {
	*chp = NULL;
	return C_FILE;
      }
    }
  }  
  i = 0;
  *chp = NULL;
  for (child = get_child(NULL, "zcat", NULL); child; child = child->next) {
    if (!(j = tabchrstr(pathname, 0, child->ext)) || !child->argv[0]) continue;
    if (*chp) if (strlen((*chp)->ext) > strlen(child->ext)) continue;
    if (pathname[j+strlen(child->ext)-1]) continue;
    *chp = child;
    if (f) strcpy(child->argv[child->argc], pathname);
    if (!strcmp(child->argv[1], "egrep")) i = C_BROW;
    else if (child->exec && cb->ff.cld) i = C_EXEC;
    else if (!strcmp(child->argv[1], "tar")) {
      i = C_TAR;
      if (f) {
	if (cb->ff.arc >= 2) ; /* lzh, unzip  tar */
	else cb->ff.arc = 1;
      }
    } else if (!strcmp(child->argv[1], "lha")) {
      i = C_LHA;
      if (f) {
	if (cb->ff.arc) ;	/* archive  lzh */	
	else cb->ff.arc = 2;
      }
    } else if (!strcmp(child->argv[1], "unzip")) {
      i = C_UNZIP;
      if (f) {
	if (cb->ff.arc) ;	/* archive  zip */	
	else cb->ff.arc = 3;
      }
    } else i = C_BIN;
  }	     
  if (!i) i = C_FILE;
  if (!f) return i;
  if (!cb->ff.cld) { /* å or 'F' ǥե륻쥯Ȥ */
    if (!arc) cb->ff.arc = 0;
    *chp = NULL;
    i = C_FILE;
  } else {
    stat(pathname, &st);
    if (!arc && st.st_size >= gl.z)
      do {
	switch(i) {
	case C_TAR:
	  if (!tabchrstr((*chp)->ext, 'z', NULL) &&
	      !tabchrstr((*chp)->ext, 'Z', NULL)) continue;
	  break;
	case C_LHA:
	case C_UNZIP:
	  break;
	case C_BIN:
	  if (strcmp((*chp)->argv[1], "zcat")) continue;
	  break;
	default:
	  continue;
	}
	i = C_BIN;
	cb->ff.arc = 0;
      } while (0);
  }
  return i;
}

void clear_base(BASE *base)/*cb*/
{ /* ƥɽƤʤ */
  if (cb->d_pid < 0) cb->d_pid = 0;
  if (base->text) {
    free(base->text);
    base->text = NULL;
  }
  base[0].pp[1].next = &base[0].pp[2];
  base[0].pp[2].prev = &base[0].pp[1];
  base[0].size = base[0].nline = 0;
}

void init_sel(int xs, int ys, int xe, int ye, int n)/*cb*/
{ /* (xs, ys)-(xe, ye) ϰϤ򥤥٥ No. n  */
  if (xs >= 0) cb->sel[n].xs = xs;
  if (ys >= 0) cb->sel[n].ys = ys;
  if (xe >= 0) cb->sel[n].xe = xe;
  if (ye >= 0) cb->sel[n].ye = ye;
}

void layer_disp(int page)/*cb*/
{ /* ɽڡ */
  int ffd, req[2];
  u_short *p;

  ffd = open("/dev/fb", O_RDWR);
  req[0] = 1 * sizeof(int) + sizeof(int);
  p = (u_short*)&req[1];
  *p++ = 34;
  switch(page) {
  case 0:  
    *p = 0;
    break;
  default:  
    *p = (cb->f.blanked) ? 0 : 3 + page;
    break;
  }  
  ioctl(ffd, FBIOCSETCRTC, req);
  close(ffd);
}

void get_home(char *pathname)/*cb*/
{ /* ۡǥ쥯ȥ̾ */
  strcpy(pathname, getenv("HOME"));
  if (strcmp(pathname, "/")) strcat(pathname, "/");
}

int get_vactive(void)/*cb*/
{ /* ü No.  */
  struct vt_stat vtstat;
  int tfd;

  tfd = open("/dev/console", O_WRONLY);
  ioctl(tfd, VT_GETSTATE, &vtstat);
  close(tfd);
  return vtstat.v_active;
}

void set_vactive(int vactive)/*cb*/
{ /* ü No.  */
  int tfd;

  tfd = open("/dev/console", O_WRONLY);
  ioctl(tfd, VT_ACTIVATE, vactive);
  close(tfd);
}

void set_palvec(int ns, int ne, char pal[])/*cb*/
{
  int ffd, i, req[17];
  char *p;

  ffd = open("/dev/fb", O_RDWR);
  req[0] = (ne-ns) * sizeof(int) + sizeof(int);
  p = (char*)&req[1];
  for (i = ns; i < ne; i++) {
    *p++ = i;
    *p++ = pal[i*3+0];
    *p++ = pal[i*3+1];
    *p++ = pal[i*3+2];
  }  
  ioctl(ffd, FBIOCSETPAL, req);
  close(ffd);
}

void get_palvec(int ns, int ne, char pal[])/*cb*/
{
  int ffd, req[4];

  ffd = open("/dev/fb", O_RDWR);
  req[0] = FBIOC_PAL_NORMAL;
  req[1] = 0;
  req[2] = 16;
  req[3] = (int)pal;
  ioctl(ffd, FBIOCGETPAL, req);
  close(ffd);
}

