#ifndef _VRAM_H
#define   x_pset() \
  do {\
    if (!(u <<= 4)) {\
      *addr++ = v;\
      v = *addr;\
      u = col;\
    }\
  } while (0)

#define   y_pset() \
  do {\
    *addr = v;\
    addr += y_inc;\
    v = *addr;\
  } while (0)

#define x_line(bit) \
  do {\
    x_pset();\
    bit;\
  } while (--p_i)

#define y_line(bit) \
  do {\
    y_pset();\
    bit;\
  } while (--q_i)

#define   draw(bit) \
  do {\
    bit;\
    if (p_d || q_d) {\
      if (!q_d) {\
        x_line(bit);\
      } else {\
        if (!p_d) {\
          y_line(bit);\
        }\
      }\
    }\
  } while (0)

static struct {
  int fb; /* VRAM ɥ쥹 */
  int addr; /* ɽ襢ɥ쥹 */
  int font; /*  ROM */
  union {
    int i;
    uint *p;
  } end;
  uint bf[LINE_LWORDS*(MY+PAGE_LINES)]; /* VRAM 256KB */
} vram;

#endif 
#define _VRAM_H
